/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_inst *e = f_new_inst(FI_EMPTY);

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  struct f_inst *s = f_new_inst_da(FI_EA_SET, dyn);
  s->a1.p = e;
  return s;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst(FI_CONSTANT);
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->fi_code == FI_CONSTANT_INDIRECT) {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst(FI_CONSTANT_INDIRECT);
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT_INDIRECT);

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->fi_code = FI_LC_CONSTRUCT;
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_path_mask *t)
{
  struct f_path_mask *tt;
  for (tt = t; tt; tt = tt->next) {
    if (tt->kind == PM_ASN_EXPR) {
      struct f_inst *mrv = f_new_inst(FI_PATHMASK_CONSTRUCT);
      mrv->a1.p = t;
      return mrv;
    }
  }

  NEW_F_VAL;
  val->type = T_PATH_MASK;
  val->val.path_mask = t;

  struct f_inst *rv = f_new_inst(FI_CONSTANT_INDIRECT);
  rv->a1.p = val;

  return rv;
}


/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from ../../proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}


#line 705 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    NMA = 277,
    DEFINE = 278,
    ON = 279,
    OFF = 280,
    YES = 281,
    NO = 282,
    S = 283,
    MS = 284,
    US = 285,
    PORT = 286,
    LOG = 287,
    SYSLOG = 288,
    ALL = 289,
    DEBUG = 290,
    TRACE = 291,
    INFO = 292,
    REMOTE = 293,
    WARNING = 294,
    ERROR = 295,
    AUTH = 296,
    FATAL = 297,
    BUG = 298,
    STDERR = 299,
    SOFT = 300,
    TIMEFORMAT = 301,
    ISO = 302,
    OLD = 303,
    SHORT = 304,
    LONG = 305,
    BASE = 306,
    NAME = 307,
    CONFIRM = 308,
    UNDO = 309,
    CHECK = 310,
    TIMEOUT = 311,
    LATENCY = 312,
    LIMIT = 313,
    WATCHDOG = 314,
    CONFIGURE = 315,
    DOWN = 316,
    KERNEL = 317,
    PERSIST = 318,
    SCAN = 319,
    TIME = 320,
    LEARN = 321,
    DEVICE = 322,
    ROUTES = 323,
    GRACEFUL = 324,
    RESTART = 325,
    KRT_SOURCE = 326,
    KRT_METRIC = 327,
    MERGE = 328,
    PATHS = 329,
    TABLE = 330,
    METRIC = 331,
    KRT_PREFSRC = 332,
    KRT_REALM = 333,
    KRT_SCOPE = 334,
    KRT_MTU = 335,
    KRT_WINDOW = 336,
    KRT_RTT = 337,
    KRT_RTTVAR = 338,
    KRT_SSTRESH = 339,
    KRT_CWND = 340,
    KRT_ADVMSS = 341,
    KRT_REORDERING = 342,
    KRT_HOPLIMIT = 343,
    KRT_INITCWND = 344,
    KRT_RTO_MIN = 345,
    KRT_INITRWND = 346,
    KRT_QUICKACK = 347,
    KRT_LOCK_MTU = 348,
    KRT_LOCK_WINDOW = 349,
    KRT_LOCK_RTT = 350,
    KRT_LOCK_RTTVAR = 351,
    KRT_LOCK_SSTRESH = 352,
    KRT_LOCK_CWND = 353,
    KRT_LOCK_ADVMSS = 354,
    KRT_LOCK_REORDERING = 355,
    KRT_LOCK_HOPLIMIT = 356,
    KRT_LOCK_RTO_MIN = 357,
    KRT_FEATURE_ECN = 358,
    KRT_FEATURE_ALLFRAG = 359,
    ROUTER = 360,
    ID = 361,
    PROTOCOL = 362,
    TEMPLATE = 363,
    PREFERENCE = 364,
    DISABLED = 365,
    DIRECT = 366,
    INTERFACE = 367,
    IMPORT = 368,
    EXPORT = 369,
    FILTER = 370,
    NONE = 371,
    VRF = 372,
    DEFAULT = 373,
    STATES = 374,
    FILTERS = 375,
    RECEIVE = 376,
    ACTION = 377,
    WARN = 378,
    BLOCK = 379,
    DISABLE = 380,
    KEEP = 381,
    FILTERED = 382,
    PASSWORD = 383,
    FROM = 384,
    PASSIVE = 385,
    TO = 386,
    EVENTS = 387,
    PACKETS = 388,
    PROTOCOLS = 389,
    INTERFACES = 390,
    ALGORITHM = 391,
    KEYED = 392,
    HMAC = 393,
    MD5 = 394,
    SHA1 = 395,
    SHA256 = 396,
    SHA384 = 397,
    SHA512 = 398,
    PRIMARY = 399,
    STATS = 400,
    COUNT = 401,
    FOR = 402,
    COMMANDS = 403,
    PREEXPORT = 404,
    NOEXPORT = 405,
    GENERATE = 406,
    ROA = 407,
    LISTEN = 408,
    BGP = 409,
    V6ONLY = 410,
    DUAL = 411,
    ADDRESS = 412,
    PASSWORDS = 413,
    DESCRIPTION = 414,
    SORTED = 415,
    RELOAD = 416,
    IN = 417,
    OUT = 418,
    MRTDUMP = 419,
    MESSAGES = 420,
    RESTRICT = 421,
    MEMORY = 422,
    IGP_METRIC = 423,
    CLASS = 424,
    DSCP = 425,
    WAIT = 426,
    MAX = 427,
    FLUSH = 428,
    AS = 429,
    SHOW = 430,
    STATUS = 431,
    SUMMARY = 432,
    ROUTE = 433,
    SYMBOLS = 434,
    ADD = 435,
    DELETE = 436,
    DUMP = 437,
    RESOURCES = 438,
    SOCKETS = 439,
    NEIGHBORS = 440,
    ATTRIBUTES = 441,
    EVAL = 442,
    ECHO = 443,
    ENABLE = 444,
    FUNCTION = 445,
    PRINT = 446,
    PRINTN = 447,
    UNSET = 448,
    RETURN = 449,
    ACCEPT = 450,
    REJECT = 451,
    QUITBIRD = 452,
    INT = 453,
    BOOL = 454,
    IP = 455,
    PREFIX = 456,
    PAIR = 457,
    QUAD = 458,
    EC = 459,
    LC = 460,
    SET = 461,
    STRING = 462,
    BGPMASK = 463,
    BGPPATH = 464,
    CLIST = 465,
    ECLIST = 466,
    LCLIST = 467,
    IF = 468,
    THEN = 469,
    ELSE = 470,
    CASE = 471,
    TRUE = 472,
    FALSE = 473,
    RT = 474,
    RO = 475,
    UNKNOWN = 476,
    GENERIC = 477,
    GW = 478,
    NET = 479,
    MASK = 480,
    PROTO = 481,
    SOURCE = 482,
    SCOPE = 483,
    CAST = 484,
    DEST = 485,
    IFNAME = 486,
    IFINDEX = 487,
    LEN = 488,
    DEFINED = 489,
    CONTAINS = 490,
    RESET = 491,
    PREPEND = 492,
    FIRST = 493,
    LAST = 494,
    LAST_NONAGGREGATED = 495,
    MATCH = 496,
    ROA_CHECK = 497,
    EMPTY = 498,
    WHERE = 499,
    BFD = 500,
    MIN = 501,
    IDLE = 502,
    RX = 503,
    TX = 504,
    INTERVAL = 505,
    MULTIPLIER = 506,
    MULTIHOP = 507,
    NEIGHBOR = 508,
    DEV = 509,
    LOCAL = 510,
    AUTHENTICATION = 511,
    SIMPLE = 512,
    METICULOUS = 513,
    SESSIONS = 514,
    HOLD = 515,
    CONNECT = 516,
    RETRY = 517,
    KEEPALIVE = 518,
    STARTUP = 519,
    VIA = 520,
    NEXT = 521,
    HOP = 522,
    SELF = 523,
    PATH = 524,
    START = 525,
    DELAY = 526,
    FORGET = 527,
    AFTER = 528,
    BGP_PATH = 529,
    BGP_LOCAL_PREF = 530,
    BGP_MED = 531,
    BGP_ORIGIN = 532,
    BGP_NEXT_HOP = 533,
    BGP_ATOMIC_AGGR = 534,
    BGP_AGGREGATOR = 535,
    BGP_COMMUNITY = 536,
    BGP_EXT_COMMUNITY = 537,
    RR = 538,
    RS = 539,
    CLIENT = 540,
    CLUSTER = 541,
    AS4 = 542,
    ADVERTISE = 543,
    IPV4 = 544,
    CAPABILITIES = 545,
    PREFER = 546,
    OLDER = 547,
    MISSING = 548,
    LLADDR = 549,
    DROP = 550,
    IGNORE = 551,
    REFRESH = 552,
    INTERPRET = 553,
    COMMUNITIES = 554,
    BGP_ORIGINATOR_ID = 555,
    BGP_CLUSTER_LIST = 556,
    IGP = 557,
    GATEWAY = 558,
    RECURSIVE = 559,
    MED = 560,
    TTL = 561,
    SECURITY = 562,
    DETERMINISTIC = 563,
    SECONDARY = 564,
    ALLOW = 565,
    AWARE = 566,
    LINK = 567,
    EXTENDED = 568,
    SETKEY = 569,
    BGP_LARGE_COMMUNITY = 570,
    LIVED = 571,
    STALE = 572,
    CEASE = 573,
    HIT = 574,
    ADMINISTRATIVE = 575,
    SHUTDOWN = 576,
    PEER = 577,
    CONFIGURATION = 578,
    CHANGE = 579,
    DECONFIGURED = 580,
    CONNECTION = 581,
    REJECTED = 582,
    COLLISION = 583,
    OF = 584,
    MRT = 585,
    FILENAME = 586,
    PERIOD = 587,
    ALWAYS = 588,
    OSPF = 589,
    AREA = 590,
    OSPF_METRIC1 = 591,
    OSPF_METRIC2 = 592,
    OSPF_TAG = 593,
    OSPF_ROUTER_ID = 594,
    RFC1583COMPAT = 595,
    STUB = 596,
    TICK = 597,
    COST = 598,
    COST2 = 599,
    RETRANSMIT = 600,
    HELLO = 601,
    TRANSMIT = 602,
    PRIORITY = 603,
    DEAD = 604,
    TYPE = 605,
    BROADCAST = 606,
    BCAST = 607,
    NONBROADCAST = 608,
    NBMA = 609,
    POINTOPOINT = 610,
    PTP = 611,
    POINTOMULTIPOINT = 612,
    PTMP = 613,
    STRICT = 614,
    CRYPTOGRAPHIC = 615,
    ELIGIBLE = 616,
    POLL = 617,
    NETWORKS = 618,
    HIDDEN = 619,
    VIRTUAL = 620,
    ONLY = 621,
    BUFFER = 622,
    LARGE = 623,
    NORMAL = 624,
    STUBNET = 625,
    TAG = 626,
    EXTERNAL = 627,
    LSADB = 628,
    ECMP = 629,
    WEIGHT = 630,
    NSSA = 631,
    TRANSLATOR = 632,
    STABILITY = 633,
    GLOBAL = 634,
    LSID = 635,
    INSTANCE = 636,
    REAL = 637,
    NETMASK = 638,
    LENGTH = 639,
    LSA = 640,
    SUPPRESSION = 641,
    TOPOLOGY = 642,
    STATE = 643,
    PIPE = 644,
    MODE = 645,
    OPAQUE = 646,
    TRANSPARENT = 647,
    RIP = 648,
    INFINITY = 649,
    UPDATE = 650,
    GARBAGE = 651,
    MULTICAST = 652,
    VERSION = 653,
    SPLIT = 654,
    HORIZON = 655,
    POISON = 656,
    REVERSE = 657,
    ZERO = 658,
    PLAINTEXT = 659,
    RIP_METRIC = 660,
    RIP_TAG = 661,
    STATIC = 662,
    PROHIBIT = 663,
    MULTIPATH = 664,
    BLACKHOLE = 665,
    UNREACHABLE = 666
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 634 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct mrt_dump_data *md;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1187 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1204 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  72
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3592

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  433
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  278
/* YYNRULES -- Number of rules.  */
#define YYNRULES  994
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1897

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   666

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     424,   425,    29,    27,   429,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   426,   423,
      23,    22,    24,   430,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   431,     2,   432,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   427,     2,   428,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   841,   841,   842,   845,   847,   855,   864,   865,   866,
     873,   874,   875,   883,   884,   885,   886,   887,   888,   894,
     895,   902,   903,   907,   914,   915,   919,   923,   930,   938,
     939,   946,   947,   951,   952,   958,   967,   968,   972,   977,
     978,   982,   983,   987,   988,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1006,  1007,  1017,  1018,  1019,  1020,
    1023,  1024,  1025,  1026,  1027,  1028,  1032,  1038,  1039,  1040,
    1041,  1049,  1052,  1059,  1062,  1065,  1068,  1072,  1073,  1077,
    1078,  1079,  1087,  1092,  1093,  1097,  1098,  1102,  1109,  1110,
    1111,  1123,  1128,  1132,  1146,  1147,  1161,  1162,  1166,  1167,
    1168,  1169,  1176,  1190,  1192,  1194,  1198,  1199,  1200,  1201,
    1206,  1212,  1213,  1217,  1225,  1229,  1231,  1237,  1238,  1245,
    1246,  1250,  1256,  1260,  1269,  1278,  1280,  1284,  1285,  1286,
    1287,  1288,  1289,  1290,  1291,  1292,  1293,  1294,  1295,  1296,
    1297,  1301,  1302,  1303,  1304,  1308,  1309,  1310,  1311,  1312,
    1316,  1322,  1326,  1334,  1335,  1343,  1351,  1352,  1353,  1357,
    1358,  1362,  1367,  1368,  1372,  1374,  1382,  1386,  1387,  1393,
    1400,  1401,  1402,  1403,  1407,  1415,  1421,  1422,  1423,  1427,
    1428,  1432,  1433,  1434,  1435,  1436,  1437,  1443,  1444,  1445,
    1449,  1450,  1454,  1455,  1461,  1462,  1465,  1467,  1471,  1472,
    1476,  1496,  1497,  1498,  1499,  1500,  1501,  1502,  1503,  1504,
    1508,  1509,  1510,  1511,  1512,  1513,  1514,  1515,  1516,  1517,
    1523,  1526,  1529,  1532,  1536,  1537,  1540,  1543,  1547,  1551,
    1556,  1562,  1569,  1574,  1579,  1584,  1588,  1592,  1596,  1605,
    1613,  1617,  1624,  1625,  1626,  1631,  1635,  1642,  1649,  1653,
    1661,  1662,  1663,  1668,  1672,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1686,  1691,  1699,  1706,  1713,  1721,  1723,  1725,
    1727,  1729,  1731,  1733,  1735,  1738,  1742,  1748,  1749,  1750,
    1754,  1755,  1761,  1763,  1765,  1767,  1769,  1771,  1775,  1779,
    1782,  1786,  1787,  1788,  1792,  1793,  1794,  1802,  1802,  1812,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1852,  1863,  1864,  1871,  1872,
    1879,  1888,  1892,  1896,  1917,  1918,  1922,  1934,  1934,  1950,
    1951,  1954,  1955,  1959,  1962,  1971,  1984,  1985,  1986,  1987,
    1988,  1992,  2000,  2001,  2002,  2003,  2004,  2008,  2011,  2012,
    2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2025,  2026,
    2027,  2028,  2032,  2033,  2034,  2038,  2039,  2040,  2041,  2042,
    2043,  2044,  2045,  2050,  2051,  2052,  2053,  2054,  2058,  2059,
    2060,  2061,  2062,  2066,  2067,  2071,  2072,  2076,  2083,  2084,
    2085,  2086,  2093,  2094,  2097,  2098,  2105,  2117,  2118,  2122,
    2123,  2127,  2128,  2129,  2130,  2131,  2132,  2136,  2137,  2138,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,  2149,  2150,  2151,
    2155,  2156,  2157,  2158,  2168,  2172,  2194,  2206,  2207,  2208,
    2209,  2210,  2211,  2212,  2213,  2214,  2215,  2219,  2220,  2221,
    2222,  2223,  2224,  2225,  2226,  2227,  2228,  2229,  2230,  2231,
    2232,  2233,  2234,  2235,  2237,  2238,  2239,  2241,  2243,  2245,
    2247,  2248,  2249,  2250,  2251,  2252,  2262,  2263,  2264,  2265,
    2266,  2267,  2268,  2269,  2271,  2272,  2275,  2297,  2298,  2299,
    2300,  2301,  2302,  2306,  2309,  2310,  2311,  2319,  2325,  2333,
    2334,  2338,  2343,  2351,  2359,  2364,  2368,  2374,  2378,  2383,
    2384,  2385,  2392,  2393,  2394,  2395,  2396,  2402,  2410,  2411,
    2412,  2413,  2416,  2418,  2422,  2426,  2440,  2460,  2461,  2462,
    2463,  2464,  2465,  2466,  2467,  2471,  2472,  2473,  2474,  2475,
    2476,  2479,  2481,  2484,  2486,  2490,  2493,  2498,  2499,  2500,
    2504,  2505,  2509,  2510,  2513,  2532,  2538,  2565,  2567,  2568,
    2573,  2574,  2578,  2579,  2583,  2584,  2585,  2586,  2587,  2588,
    2589,  2590,  2591,  2595,  2596,  2597,  2598,  2599,  2600,  2606,
    2607,  2608,  2609,  2610,  2611,  2612,  2613,  2614,  2615,  2616,
    2617,  2618,  2619,  2620,  2621,  2622,  2623,  2624,  2625,  2626,
    2627,  2628,  2629,  2630,  2631,  2632,  2633,  2634,  2635,  2636,
    2637,  2638,  2639,  2640,  2641,  2642,  2643,  2644,  2645,  2651,
    2652,  2653,  2654,  2655,  2656,  2657,  2658,  2659,  2660,  2661,
    2662,  2663,  2664,  2665,  2666,  2667,  2668,  2669,  2670,  2681,
    2687,  2688,  2689,  2690,  2691,  2692,  2693,  2696,  2698,  2702,
    2705,  2709,  2710,  2711,  2712,  2713,  2714,  2721,  2731,  2732,
    2736,  2737,  2738,  2739,  2740,  2741,  2742,  2743,  2744,  2747,
    2762,  2765,  2767,  2771,  2772,  2773,  2774,  2775,  2776,  2777,
    2778,  2779,  2780,  2780,  2781,  2781,  2782,  2783,  2784,  2788,
    2789,  2793,  2801,  2803,  2807,  2808,  2809,  2813,  2814,  2817,
    2819,  2822,  2823,  2824,  2825,  2826,  2827,  2828,  2829,  2830,
    2831,  2832,  2835,  2855,  2856,  2857,  2858,  2859,  2860,  2861,
    2862,  2863,  2864,  2865,  2866,  2867,  2868,  2869,  2870,  2871,
    2872,  2873,  2874,  2875,  2876,  2877,  2878,  2879,  2880,  2881,
    2882,  2883,  2884,  2885,  2886,  2887,  2888,  2889,  2890,  2891,
    2892,  2893,  2896,  2898,  2901,  2903,  2912,  2914,  2915,  2918,
    2920,  2924,  2925,  2928,  2938,  2959,  2961,  2965,  2965,  2968,
    2970,  2973,  2975,  2979,  2984,  2987,  2990,  2995,  2998,  3003,
    3006,  3010,  3014,  3017,  3018,  3019,  3020,  3021,  3022,  3023,
    3024,  3030,  3037,  3038,  3039,  3044,  3045,  3051,  3064,  3065,
    3066,  3067,  3068,  3071,  3073,  3077,  3081,  3104,  3134,  3135,
    3136,  3137,  3138,  3139,  3140,  3144,  3145,  3146,  3147,  3148,
    3149,  3150,  3151,  3152,  3153,  3154,  3155,  3156,  3157,  3158,
    3159,  3160,  3161,  3165,  3166,  3167,  3168,  3171,  3173,  3176,
    3178,  3182,  3188,  3191,  3198,  3205,  3206,  3207,  3208,  3209,
    3212,  3222,  3231,  3235,  3241,  3242,  3246,  3251,  3257,  3260,
    3265,  3266,  3267,  3268,  3269,  3273,  3274,  3277,  3279,  3282,
    3284,  3288,  3295,  3295,  3295,  3295,  3295,  3295,  3295,  3295,
    3295,  3295,  3295,  3295,  3295,  3295,  3295,  3295,  3296,  3296,
    3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,
    3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,
    3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,
    3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,
    3296,  3296,  3296,  3296,  3296,  3296,  3296,  3296,  3297,  3297,
    3297,  3297,  3297,  3297,  3297,  3297,  3297,  3297,  3298,  3298,
    3298,  3298,  3299,  3299,  3299,  3300,  3300,  3300,  3300,  3300,
    3300,  3300,  3300,  3300,  3300,  3300,  3300,  3300,  3300,  3300,
    3300,  3300,  3300,  3300,  3300,  3300,  3300,  3300,  3300,  3300,
    3300,  3300,  3300,  3300,  3300,  3300,  3301,  3301,  3302,  3303,
    3304,  3305,  3306,  3307,  3308,  3309,  3310,  3311,  3312,  3313,
    3313,  3313,  3313,  3313,  3313
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "VRF", "DEFAULT",
  "STATES", "FILTERS", "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE",
  "KEEP", "FILTERED", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS",
  "PACKETS", "PROTOCOLS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC",
  "MD5", "SHA1", "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT",
  "FOR", "COMMANDS", "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN",
  "BGP", "V6ONLY", "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED",
  "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY",
  "IGP_METRIC", "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "PATH",
  "START", "DELAY", "FORGET", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF",
  "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR",
  "BGP_AGGREGATOR", "BGP_COMMUNITY", "BGP_EXT_COMMUNITY", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4", "CAPABILITIES",
  "PREFER", "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH",
  "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST",
  "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC",
  "SECONDARY", "ALLOW", "AWARE", "LINK", "EXTENDED", "SETKEY",
  "BGP_LARGE_COMMUNITY", "LIVED", "STALE", "CEASE", "HIT",
  "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE",
  "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF", "MRT",
  "FILENAME", "PERIOD", "ALWAYS", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL",
  "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL",
  "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA", "SUPPRESSION",
  "TOPOLOGY", "STATE", "PIPE", "MODE", "OPAQUE", "TRANSPARENT", "RIP",
  "INFINITY", "UPDATE", "GARBAGE", "MULTICAST", "VERSION", "SPLIT",
  "HORIZON", "POISON", "REVERSE", "ZERO", "PLAINTEXT", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa", "pxlen",
  "datetime", "text", "opttext", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "debug_unix", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT",
  "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cfg_name", "cfg_timeout", "kern_proto_start",
  "kern_mp_limit", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "gr_opts", "tab_sorted", "newtab", "roa_table_start", "roa_table_opts",
  "roa_table", "proto_start", "proto_name", "proto_item", "imexport",
  "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "export_mode",
  "cmd_SHOW_ROA", "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args",
  "roa_table_arg", "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def",
  "$@1", "filter_eval", "type", "one_decl", "decls", "declsn",
  "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "cnum", "pair_item", "ec_kind",
  "ec_item", "lc_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_finish",
  "bfd_iface_item", "bfd_auth_type", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_nbr_opts",
  "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag", "bgp_proto",
  "mrt_proto_start", "mrt_proto_item", "mrt_proto_opts", "mrt_proto",
  "cmd_MRT_DUMP", "mrt_dump_args", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_proto_start",
  "rip_proto_item", "rip_proto_opts", "rip_proto", "rip_iface_start",
  "rip_iface_finish", "rip_iface_item", "rip_auth", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface", "cmd_SHOW_RIP_INTERFACES",
  "cmd_SHOW_RIP_NEIGHBORS", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,    59,    40,    41,    58,   123,   125,    44,
      63,    91,    93
};
# endif

#define YYPACT_NINF -1498

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1498)))

#define YYTABLE_NINF -490

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-490)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     104,  3244,   244,   743,   547,  1184,   125,   547,   547,   791,
     547,   188,    96,  1421,   175,   186,  1173,  1878,    23,   547,
     184, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498,   372,  1136,   313,   639,   215,   323,
     391,   302, -1498, -1498,   466,   351,   325,   508,  1878,   527,
   -1498, -1498, -1498, -1498, -1498, -1498,    87,    87, -1498, -1498,
   -1498, -1498,   151, -1498,   595, -1498,    87,  3061, -1498, -1498,
   -1498,    87, -1498,    87,  2953,    87, -1498,    87,  2665,    87,
    2997,    87, -1498,    87,  2795, -1498, -1498,  2598,  3164, -1498,
   -1498, -1498,    68, -1498,   563,   608,   614,   563,   575, -1498,
     582,   582,   547,   547,   641,   242, -1498,   577,   714,   190,
   -1498,   654,   673, -1498, -1498,   416,   524,   191,   686,   571,
     571,   685,   710,   720,   744,   758,   770,   805,   813,    62,
   -1498, -1498, -1498,   795,   474, -1498,   576,   128,    39,  1878,
   -1498,   476,   478,   485, -1498, -1498,   502,   505,   511,  1042,
     152, -1498, -1498, -1498, -1498, -1498,  2518, -1498,  2866, -1498,
   -1498,  1832,   917,   582, -1498,   916, -1498, -1498,   879, -1498,
   -1498,    18,   371,    68,   279, -1498, -1498, -1498, -1498,   376,
     532,   279,   279,   776,   802,   146, -1498,   947, -1498,   242,
     552,  2965, -1498,   852,   975,   587,   589, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,   596,    68,
     702,  1028,   936,   279,   766, -1498,   912,   535,   168,   995,
     717,   242, -1498,   653,   659,   646,   665,   -64,   759,   771,
    1030,   692,  1098,   546,   838,   717,   766,  1055,  1054,    94,
     973,   481,    36,   571,   117,  1084,   -57,  1100,   918,   901,
    1106,   913,   590,   907,   925,   766,   905,   921,   903,   756,
      -6,  1141,   911,   923,   766,   418,   766, -1498,   809,   810,
     814,   859,    55,   766,  1130,   279,   766,  1134, -1498, -1498,
     830,   833, -1498,   835,  1177,   491, -1498,   841,   840,   853,
     945,   571,  1197, -1498,   862,   433,   861,  1203,   766,  1215,
     766,  1213,  1212,  1218,   279, -1498,   881,   882,   883,  1233,
     582, -1498,   887,   889, -1498, -1498,  1135,  1310,   575, -1498,
   -1498,  1320,   279,  1322, -1498,  1323,  1324,  1325,  1332, -1498,
   -1498, -1498,   223,  1334,  1305,  1349, -1498, -1498,   897,  1350,
   -1498,  1353,   542, -1498, -1498,  3314,  1158,   686, -1498,   686,
     686, -1498,   207,   475,  1354,   686,   686,  1357, -1498, -1498,
      65,  1178,  1179, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498,    31, -1498,    62,  1878,    62,    62,  1351, -1498,  1356,
    1110,  1339,   148,  1344,    39,    39,  1343,  1341,  1878,  1878,
    1878,  1878,  1878,  1359, -1498, -1498,  1365, -1498,   952,   122,
   -1498, -1498, -1498, -1498,   990, -1498,  1376, -1498, -1498, -1498,
   -1498,  -217,    29, -1498,    22, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,  1878,  1878,
    1878,  1878,  1878,  1878,  1878,  1878,  1878,  1878,  1878,  1878,
    1878,  1878,  1221, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498,   492, -1498, -1498,  1381,  1388,   708,  1878,   717,
   -1498, -1498,  1832,   976, -1498, -1498, -1498, -1498, -1498, -1498,
     279,  1878, -1498, -1498, -1498, -1498,   279,   885,   919, -1498,
     817, -1498, -1498,   279, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498,  1878,   977,  3132, -1498,   625,   980, -1498,   974,  1382,
   -1498, -1498, -1498,   -66, -1498, -1498,   766, -1498, -1498,    55,
   -1498, -1498, -1498, -1498,    63,  2368, -1498,  1270,  1878, -1498,
   -1498,    63, -1498, -1498, -1498,    63, -1498, -1498, -1498, -1498,
   -1498, -1498,  1335,  1337,     3,   766,   707, -1498,   992,   279,
     279,    15,   993,   997,   279,    74,  1114,   766,  1242,   571,
    1002,  1004, -1498,  1006,  1408,    58,   279,  1255,   279,  1366,
    1367,   279,  1368,    81,   766,  1370,  1018,  1345,  1035,   766,
    1037,   766,   364,   766,  1028,   766,  1038,  1040,   766,   766,
     766,  1044,  1283,   766,  1051, -1498, -1498, -1498,   766, -1498,
   -1498,   766, -1498,  1406,   279, -1498, -1498, -1498,  1457,  1056,
    1061, -1498, -1498, -1498,   766, -1498,  1028, -1498, -1498,   978,
   -1498,   571, -1498,  1210, -1498, -1498, -1498,  1065,   279, -1498,
     279, -1498,   766,   766,   766, -1498, -1498, -1498, -1498,   279,
     571, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,   583,
   -1498, -1498,  1489, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498,   599, -1498, -1498, -1498, -1498,  1491, -1498, -1498,
   -1498,  1477, -1498, -1498,  1483,   571, -1498, -1498,  1482,  1487,
   -1498,  2368, -1498, -1498, -1498, -1498,   571, -1498, -1498, -1498,
    1492, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
    1499,  1488,  1488,   908,   686,  1488,   686,  1488, -1498,  1488,
    1488, -1498,   279,   571, -1498,  1497,  1500,  1501, -1498, -1498,
     960, -1498, -1498, -1498, -1498,   212, -1498,  1089, -1498,  1264,
    1495, -1498, -1498, -1498, -1498,   295,   346,   530,  1079,   597,
      -9, -1498,  1878, -1498,  1878,  1090,    17,  1097,  1321,   232,
     616, -1498, -1498, -1498,  1514,  1510, -1498,  2679,  2679,  2679,
    2791,  2791,  2679,  2679,  2679,  2679,  2679,   725,   725,  1341,
    1341, -1498,  1107, -1498, -1498, -1498, -1498, -1498,  1832, -1498,
   -1498, -1498,  1014,  2368,   717, -1498,  1124, -1498,   615, -1498,
   -1498,  1426,  1518, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
    1116, -1498,  1117,  1747, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,   135,
    1120,  1103, -1498, -1498,   279, -1498, -1498,   571, -1498, -1498,
   -1498,  1768,  3132, -1498,   571, -1498,  1131, -1498,  1505, -1498,
    1126, -1498,  1423, -1498, -1498, -1498, -1498,   766,  2965, -1498,
   -1498,  2608,   279,   279,  1476,  1498,  1152,   279,  1153,  1154,
   -1498,  1155,  1156,   766,   102, -1498, -1498,  1157,  1159,  1160,
    1166,   766,  1167,   766,  1171, -1498, -1498, -1498,  1539, -1498,
     279,   279, -1498,  1174,   279,  1180,   279,   279,  1181,   279,
    1186,  1189,  1190,   279, -1498,    55, -1498,  1195, -1498,  1198,
    1201,  1204,  1205,  1206,  1208,  1209, -1498, -1498,  1211,  1222,
    1223, -1498,   241,  1224, -1498,  2939, -1498, -1498,   279, -1498,
    1036,  1225, -1498, -1498,  2921,  1226,  1227, -1498,  1408, -1498,
     571,   -98,  1210,  1885, -1498, -1498, -1498, -1498, -1498,  1532,
   -1498,    65, -1498, -1498, -1498,  1135, -1498, -1498,   223, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
    1599,  1632, -1498, -1498,    55, -1498, -1498,    55,  1621, -1498,
      55,  1488,  1652,  1488,  1654,  1655,  1657, -1498, -1498,  1478,
    1479,    62, -1498,  1878, -1498,  1633,  1634,  1878,  1878,  1878,
   -1498,  1878, -1498,  1878,   669,   172,  1377,  1878,  1533,  1878,
   -1498, -1498,  1878, -1498, -1498,  1239,   795, -1498,  1878, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,  1126,
   -1498, -1498, -1498, -1498,  3132,   668, -1498, -1498, -1498,  1246,
    1245, -1498,  1490, -1498, -1498,   982, -1498,   985, -1498, -1498,
   -1498, -1498,   571, -1498, -1498,  1249,  1247,  1251,   693,   279,
   -1498,  1252, -1498, -1498, -1498, -1498,  1256,   863, -1498,  1257,
   -1498, -1498, -1498, -1498,  1258, -1498,  1265, -1498, -1498,    99,
   -1498, -1498, -1498,  1272, -1498,  1273,  1274, -1498,  1276, -1498,
   -1498, -1498,  1282,  1284, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498,  1285, -1498,  1048,  2368,
     717,   279,  1519, -1498, -1498, -1498,  1286, -1498, -1498,   195,
     766,   194, -1498,  1355,   571, -1498, -1498,   550, -1498,  1288,
   -1498,  1330, -1498, -1498,   766,   279, -1498, -1498,  1289, -1498,
   -1498, -1498,  1408,   766,   279,   -98,     6, -1498,  1692, -1498,
   -1498,  1302,  1878, -1498, -1498, -1498,  1878,  1878,   766, -1498,
    2518,  1304,  1624, -1498, -1498,   279, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498,  1728, -1498,  1729, -1498, -1498,
   -1498,  1718,  1719, -1498, -1498,  1707, -1498,  1943,  2001,  2091,
    2124,   741,  1878, -1498,  1878,   226,    38,  2965,  1307,   260,
      14,  1314,  1321,  1724,  2151, -1498,  1317,    69, -1498,  3132,
   -1498,  1732,   571, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498,  1326, -1498,    76, -1498, -1498,   279, -1498,  1328,
    1329,  1331, -1498, -1498,  1409,  1679, -1498,   -70,  1424,  1428,
     775,   671, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,  1484, -1498,
   -1498, -1498,   279,   279,   766, -1498,   279, -1498,  1338,    55,
   -1498, -1498,  1340,  1352,   279, -1498, -1498,   279,  1358, -1498,
   -1498,  1713, -1498, -1498, -1498, -1498, -1498,  1878,  1110,  1878,
   -1498,  2405,  2542,   855,  1360,  1762,   181, -1498,  2965,  1361,
    1364, -1498, -1498, -1498,   577,   577,  1760, -1498, -1498, -1498,
   -1498,  1878,  2177,  2214, -1498,  1763,  1878, -1498,  1674, -1498,
    1764,  1878,  1782,  1804,  1830,  1363, -1498, -1498, -1498, -1498,
    1610, -1498,  1126,  1326, -1498, -1498,  1777,   717,  1531,  1375,
   -1498, -1498, -1498,  1605,  1472, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498,   863,   766,  1126,  1378, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498,  1379,   279,  2431,
    1384,  2457,  2848, -1498,  1513, -1498, -1498,  1878,  1878,   656,
    1624, -1498,  1800,  1801, -1498,  2240, -1498, -1498,  1385,  1386,
     296,    40,  1387,   406,  1383,  1389,    41,  1393,    42, -1498,
    1798, -1498,   774, -1498, -1498, -1498,   571,  1563, -1498, -1498,
   -1498, -1498, -1498,  1330, -1498, -1498,    34,   -86,    43,  1019,
   -1498, -1498, -1498, -1498, -1498, -1498,  1402,   668,  1602, -1498,
      25,  2484,  2510,  1405,  1411,  1413,  1414,  1407, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498,  1811,  1878, -1498, -1498, -1498,
    1812,  1878, -1498,  1878,  1835, -1498,  1878, -1498,  1431, -1498,
     717,   766,  1417,   884,  1595,   279,   279,   679, -1498, -1498,
   -1498,  1429,  1438, -1498,   766, -1498, -1498,  3053, -1498, -1498,
   -1498,   107,   766,   279,   766, -1498,  1440, -1498,   279,   202,
     279,   279,  1582,   138, -1498, -1498,  1444,  2596, -1498,  1445,
    1442,  1513,   108, -1498, -1498, -1498,   990, -1498, -1498,  1864,
   -1498, -1498, -1498, -1498,   155, -1498, -1498,  1878,  1878,  1878,
    1878, -1498,  1448,  1449,  1450,  1447,  1462,  1464,  1465, -1498,
   -1498, -1498,  1750,  1631,  1638,  1639, -1498, -1498, -1498,  1013,
   -1498,  1753, -1498,   772, -1498, -1498,  1584,   279,  1493,   766,
    1543,   419,   450,  1591,   766,  1527,   766,   279,   279,   279,
    1643,   279,   189,  1549,  1534,  1562,   279,  1545,  1567, -1498,
   -1498,  1509, -1498,   279,  1511, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498,   279,   279, -1498, -1498,   279,
    -204,  1857,   279,   766,   571,   766,  1557,   465,   -35,  1619,
    1552,    21,  1863,  1865,    75,  1535,  1529, -1498, -1498,  1520,
   -1498, -1498, -1498, -1498,  2266,   348,   108,   621,  2295,  2321,
    2347,  2373, -1498, -1498, -1498,  1878, -1498,  1878, -1498,  1516,
    1522,   279,   279,   279, -1498, -1498,  1033,   279,  1927,  1927,
    1058,   383,   393,  1521,   766, -1498, -1498, -1498,   192,   279,
     279,   279,   279, -1498, -1498, -1498, -1498,   761, -1498,  1551,
   -1498, -1498, -1498, -1498,   279, -1498,   279, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498,   766,   766, -1498,   279,
     766, -1498, -1498, -1498, -1498, -1498, -1498,   766,   766,   279,
   -1498, -1498, -1498, -1498,   279,   279,   279, -1498, -1498, -1498,
   -1498, -1498, -1498,   803,   279, -1498, -1498,   279,   279,   766,
   -1498,   766,   766, -1498, -1498,  1878, -1498, -1498, -1498,  1536,
    1537,  1538,  1540,  1550,  1556, -1498,  1750, -1498, -1498, -1498,
   -1498, -1498,  1569, -1498,  1570,  1571,  1021,  1105,  1574,  1927,
    1927,  1927,  1927, -1498, -1498,    46, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498,  1581, -1498,   766, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,  1585, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498,  2266, -1498, -1498, -1498,
   -1498, -1498,  1878, -1498,   772,   772,   772, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498,   772,  1576,  1577,
    1578,  1579, -1498,  1635, -1498, -1498, -1498, -1498,  1586, -1498,
   -1498, -1498, -1498,   772,   772,   772,   772, -1498,  1580,  1878,
   -1498, -1498, -1498, -1498, -1498,  1583, -1498
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   424,     0,     0,
       0,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,     3,     1,     2,     0,     0,     0,     0,     0,     0,
       0,     0,   119,   120,     0,     0,     0,     0,   424,     0,
     862,   863,   864,   865,   866,   867,   121,   121,   868,   869,
     870,   871,   117,   872,     0,   874,   121,   125,   875,   876,
     877,   121,   931,   121,   125,   121,   933,   121,   125,   121,
     125,   121,   936,   121,   125,     5,   873,   125,   125,   291,
     293,   292,     0,    78,    77,     0,     0,    77,    79,    76,
      34,    34,     0,     0,     0,     0,   290,   262,   295,     0,
     246,     0,     0,   229,   254,     0,   225,     0,   225,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   406,
     410,   419,   416,   335,   426,   413,     0,     0,   409,   424,
     457,     0,     0,     0,   411,   412,     0,     0,     0,   424,
       0,   414,   415,   423,   455,   456,     0,   454,     0,   278,
     277,     0,   280,    34,   641,     0,    30,    29,    37,    40,
      38,     0,    18,     0,     0,    59,    58,    57,    56,     0,
       0,     0,     0,     0,   111,     0,   297,     0,   104,     0,
       0,   299,   327,   122,     0,     0,     0,   115,    82,    91,
     169,   546,   507,   629,   647,   781,   787,   834,     0,     0,
       0,     0,     0,     0,    18,   174,     0,     0,     0,     0,
       0,     0,   930,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,    18,     0,   547,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,    18,     0,    18,   932,     0,     0,
       0,     0,     0,    18,     0,     0,    18,     0,   934,   650,
       0,     0,   658,     0,     0,     0,   935,     0,     0,     0,
       0,     0,     0,   937,     0,     0,   859,     0,    18,     0,
      18,     0,     0,     0,     0,   928,     0,     0,     0,     0,
      34,   929,     0,     0,   177,   176,     0,     0,    79,    73,
      74,     0,    80,     0,    33,     0,     0,     0,     0,   285,
     188,   187,     0,     0,     0,     0,   294,   296,   295,     0,
     226,     0,   250,   221,   220,     0,     0,   225,   224,   225,
     225,   772,   225,   225,     0,   225,   225,     0,    19,    20,
       0,     0,     0,   273,   269,   274,   270,   267,   268,   271,
     272,   406,   426,   406,   424,   406,   406,     0,   397,     0,
     424,     0,     0,     0,   409,   409,     0,   452,   424,   424,
     424,   424,   424,     0,   358,   359,     0,   361,     0,     0,
     336,   339,   337,   341,   424,   338,   376,   373,   374,   375,
     383,     0,   388,   392,     0,   976,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   427,   975,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   978,   981,   980,
     977,   979,   982,   983,   984,   987,   985,   986,   988,   989,
     990,   991,   992,   993,   994,   458,   459,   275,   424,   424,
     424,   424,   424,   424,   424,   424,   424,   424,   424,   424,
     424,   424,     0,    45,    46,    47,    48,    49,    50,    51,
      52,    53,     0,    43,   281,     0,     0,     0,   424,     0,
      39,    41,     0,     0,     7,     9,    14,    16,    15,    17,
       0,   424,    13,    67,   153,   154,    60,     0,     0,    66,
       0,    69,    70,     0,   112,   113,    98,   100,   101,   102,
     165,   424,     0,   316,   114,     0,     0,    55,     0,     0,
     123,   938,   942,     0,   170,   128,    18,   152,   138,     0,
     126,   127,   155,   143,     0,   316,   144,     0,   424,   130,
     142,     0,   131,   137,   136,     0,   140,   129,   171,   172,
     512,   563,     0,     0,     0,    18,    18,   575,     0,     0,
       0,     0,     0,     0,     0,    18,     0,    18,     0,     0,
       0,     0,   576,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,     0,     0,     0,     0,    18,
       0,    18,     0,    18,     0,    18,     0,     0,    18,    18,
      18,     0,     0,    18,     0,   564,   637,   648,    18,   659,
     651,    18,   656,   653,     0,   649,   661,   782,     0,     0,
       0,   783,   793,   835,    18,   840,     0,   836,   851,     0,
     850,     0,   854,     0,   852,   853,   857,     0,     0,    85,
       0,    87,    18,    18,    18,    95,   940,   941,   939,     0,
       0,   944,   943,   182,   181,   183,   185,   186,   184,     0,
     179,   288,     0,    75,    81,    71,   284,   282,   286,   287,
     192,   193,     0,   190,   289,   263,   266,     0,   222,   227,
     245,     0,   252,   251,     0,     0,   228,   235,     0,     0,
     243,   316,   237,   236,   240,   241,     0,   242,   244,   230,
       0,   234,   253,   261,   255,   258,   259,   257,   260,   256,
       0,    32,    32,     0,   225,    32,   225,    32,   764,    32,
      32,   861,     0,     0,    23,     0,     0,     0,   401,   403,
       0,   404,   405,   399,   387,   487,   490,     0,   466,     0,
       0,   467,   407,   408,   400,     0,     0,     0,     0,     0,
       0,   360,   424,   437,   424,     0,     0,     0,   347,     0,
       0,   417,   389,   390,     0,     0,   418,   449,   447,   445,
     442,   443,   444,   446,   448,   450,   451,   438,   439,   440,
     441,   460,     0,   461,   463,   464,   465,   279,     0,   276,
     283,   640,     0,   316,     0,   645,     0,    36,     0,    35,
      68,     0,     0,    62,    63,    64,    65,    10,    11,    12,
       0,   155,     0,     0,    96,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,     0,
       0,     0,   298,   320,     0,   108,   109,     0,   103,   105,
      54,     0,   316,   124,     0,   118,     0,   139,   159,   162,
     175,   151,   145,   133,   321,   322,   141,    18,   323,   134,
     132,   125,     0,     0,     0,     0,     0,     0,     0,     0,
     569,     0,     0,    18,    18,   606,   609,     0,     0,     0,
       0,    18,     0,    18,     0,   628,   627,   577,     0,   547,
       0,     0,   567,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   571,     0,   572,     0,   604,     0,
       0,     0,     0,     0,     0,     0,   583,   584,     0,     0,
       0,   611,     0,     0,   607,   125,   655,   652,     0,   657,
       0,     0,   785,   786,   125,     0,     0,   847,    21,   849,
       0,   844,   848,   424,   839,    94,    86,    88,    89,    83,
      92,    25,    24,    93,   178,     0,    72,   189,     0,   223,
     249,   248,   247,   232,   239,   233,   231,   238,   545,    31,
       0,     0,   771,   780,     0,   778,   775,     0,     0,   773,
       0,    32,     0,    32,     0,     0,     0,    26,    27,     0,
       0,   406,   398,   424,   476,     0,     0,   424,   424,   424,
     453,   424,   474,   424,     0,     0,   424,   424,   424,   424,
     340,   335,   424,   377,   384,     0,     0,   393,   424,    44,
     643,   642,   644,   646,     6,    42,     8,    61,   110,   166,
      97,    99,   315,   314,   316,   424,   107,   106,   325,   318,
       0,   328,     0,   173,   160,     0,   155,     0,   150,   135,
     515,   515,     0,   514,   508,     0,     0,     0,    18,     0,
     626,     0,   619,   618,   591,   590,     0,     0,   550,     0,
     608,   612,   613,   614,     0,   602,     0,   592,    22,     0,
     548,   549,   565,     0,   573,     0,     0,   596,     0,   579,
     578,   585,     0,     0,   605,   588,   580,   581,   582,   610,
     624,   587,   586,   625,   589,   616,     0,   615,     0,   316,
       0,     0,     0,   639,   630,   633,     0,   654,   754,     0,
      18,    18,   672,     0,     0,   674,   664,    18,   660,     0,
     678,   755,   784,   796,    18,     0,   795,   788,     0,   837,
     838,   846,    21,    18,     0,   845,     0,   480,     0,   481,
     482,     0,   424,   478,   479,   477,   424,   424,    18,   860,
       0,     0,   424,   855,   858,     0,    90,   180,   191,   766,
     765,   779,   774,   776,   777,     0,   767,     0,   769,   832,
     833,     0,     0,   402,   488,     0,   468,     0,     0,     0,
       0,     0,   424,   420,   424,     0,     0,   347,     0,     0,
       0,     0,     0,     0,     0,   317,     0,   424,   331,     0,
     324,     0,   156,   157,   161,   163,   148,   146,   147,   149,
     155,   509,   533,   510,   537,   511,   513,     0,   597,     0,
       0,     0,   620,   599,     0,     0,   554,     0,     0,     0,
       0,     0,   552,   600,   601,   603,   568,   566,   595,   594,
     574,   593,   570,   617,   631,   632,   634,   635,     0,   638,
     155,   677,     0,     0,    18,   665,     0,   663,     0,     0,
     681,   676,   680,     0,     0,   670,   662,     0,   688,   155,
     792,   789,   791,   794,   841,   843,   842,   424,   424,   424,
     424,     0,     0,     0,     0,     0,     0,   500,   483,   485,
       0,    84,   768,   770,   262,   262,     0,   473,   471,   472,
     470,   424,     0,     0,   356,     0,   424,   354,   424,   350,
       0,   424,   348,   424,   424,     0,   462,   326,   332,   319,
       0,   158,   164,   533,   531,   516,     0,     0,   540,     0,
     622,   621,   623,     0,     0,   558,   556,   557,   560,   559,
     561,   551,     0,    18,   757,   761,   667,   668,   666,   669,
     742,   702,   682,   742,   671,   756,   689,   829,     0,     0,
       0,     0,     0,   494,   424,   394,   856,   424,   424,     0,
     424,   499,     0,     0,   469,     0,   421,   422,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   391,
       0,   516,     0,   536,   538,   539,     0,   542,   598,   562,
     555,   553,   636,   755,   759,   763,     0,     0,     0,   691,
     827,   797,   790,   493,   425,   497,     0,   424,   491,   333,
       0,     0,     0,     0,     0,     0,     0,     0,   486,   264,
     265,   475,   371,   355,   353,     0,   424,   351,   369,   349,
       0,   424,   367,   424,   365,   364,   424,   362,     0,   535,
       0,    18,     0,     0,     0,     0,     0,     0,   534,   524,
     195,   199,     0,   541,    18,   544,   758,     0,   673,   745,
     743,   746,    18,     0,    18,   679,     0,   675,     0,     0,
       0,     0,     0,     0,   687,   701,     0,     0,   831,     0,
       0,   424,   424,   342,   346,   344,   424,   501,   345,   381,
     378,   379,   380,   385,     0,   496,   495,   424,   424,   424,
     424,   502,     0,     0,     0,     0,     0,     0,     0,   116,
     200,   522,   196,     0,     0,     0,   517,   521,   525,     0,
     526,     0,   523,   201,   532,   543,     0,     0,     0,    18,
       0,     0,     0,     0,    18,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   762,
     741,     0,   747,     0,     0,   685,   686,   684,   683,   695,
     698,   699,   700,   693,   692,     0,     0,   696,   690,     0,
       0,     0,     0,    18,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   830,   822,     0,
     498,   334,   492,   396,   347,     0,   424,     0,     0,     0,
       0,     0,   370,   352,   368,   424,   366,   424,   363,     0,
       0,     0,     0,     0,   527,   528,     0,     0,     0,     0,
       0,     0,     0,     0,    18,   707,   749,   739,     0,     0,
       0,     0,     0,   734,   728,   729,   730,    18,   740,     0,
     723,   703,   706,   704,     0,   721,     0,   708,   710,   711,
     712,   713,   714,   715,   716,   717,    18,    18,   705,     0,
      18,   760,   748,   744,   694,   697,   803,    18,    18,     0,
     798,   801,   802,   820,     0,     0,     0,   815,   823,   826,
     825,   824,   821,    18,     0,   800,   799,     0,     0,    18,
     804,    18,    18,   828,   343,   424,   382,   395,   386,     0,
       0,     0,     0,     0,     0,   194,   196,   518,   519,   520,
     529,   530,     0,    28,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   198,   724,     0,   732,   731,   733,   167,
     168,   735,   736,     0,   737,    18,   720,   709,   719,   722,
     725,   718,   819,   808,   810,   813,   816,   814,     0,   817,
     812,   809,   811,   805,   806,   807,     0,   506,   504,   505,
     503,   357,   424,   197,   201,   201,   201,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   201,     0,     0,
       0,     0,   727,   751,   750,   738,   726,   818,     0,   208,
     206,   207,   209,   201,   201,   201,   201,   752,     0,   424,
     202,   203,   204,   205,   753,     0,   372
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1498, -1498, -1498, -1498,   -36,  -221,  -237,  -278,  -912,  -152,
    -748, -1498,  -732,   -85,    30,    51, -1498, -1498, -1498, -1498,
    1422,  1148, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498,   650,  1656, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498,  -309, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498,  1372,  -105,  1759, -1498,   234,  -522, -1498,
   -1498, -1498, -1498,   902,  -590,   670, -1498, -1498,   350, -1498,
   -1498, -1498, -1498,   235, -1498,  1010,   164, -1498,  1008, -1162,
     224, -1497, -1498,  -269, -1498, -1498, -1498, -1498, -1498,  -126,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
    -163, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498,   942,  1659, -1498, -1498, -1498,
   -1498,  -885,   934,   760,  1458,  -741,  -381, -1498,  1128, -1498,
   -1498, -1291, -1498,   471,  -180,  1214,   359, -1043, -1402,  1856,
   -1357, -1340,  1216,   363, -1498, -1498,  -176,  1219, -1498, -1498,
   -1498, -1498,  -386,   792, -1498, -1498,  -976, -1498,  -158,   821,
     -17, -1498, -1498,   603,   998,   698,  -997, -1498, -1498, -1498,
   -1498,   939,   591, -1498, -1498, -1498,   660, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498,  1108, -1498, -1498,   642, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498,   632, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498,   585, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498,  1059, -1498, -1498, -1498, -1498,
   -1498, -1498, -1498, -1498, -1498, -1498, -1498, -1150
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    91,   562,   571,   563,   400,   959,  1022,
    1023,   794,  1804,   210,  1040,   365,    92,   550,   211,   553,
     542,   543,    93,   219,   220,    94,    95,    21,    22,    23,
      24,    25,    26,   138,   363,    96,  1236,   346,    97,   352,
     347,    98,   582,    99,   585,   909,   100,   575,   101,   102,
     593,   103,   104,   235,   263,   609,  1118,   923,   598,   105,
     918,  1284,  1115,   919,  1402,  1403,   881,   882,  1723,   106,
     107,   602,   264,   357,   729,   730,   373,   742,   743,  1539,
    1699,  1540,  1541,  1713,  1808,    27,    28,    29,    30,   394,
      31,    32,    33,   385,   770,    34,   382,   755,    35,   386,
     375,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,   202,   545,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   132,   379,   108,   583,   109,
     899,   900,   901,  1110,   925,   926,   610,   912,   903,   110,
     588,  1276,  1277,  1498,   191,   446,  1579,   826,   447,   827,
     448,   449,   450,  1583,   451,  1584,   192,   453,   454,  1500,
     416,   193,   417,   426,   194,   195,   196,  1231,   197,   515,
    1267,  1232,  1369,  1370,   806,   807,  1278,   111,  1125,   931,
     112,  1290,  1473,  1542,  1612,  1472,  1405,  1291,  1293,  1408,
    1477,  1545,  1295,    58,   113,   645,  1139,  1311,  1312,   114,
     115,  1186,   995,   116,    59,   547,   117,   118,   320,   321,
     322,  1000,  1199,  1338,  1343,  1341,  1342,  1487,  1556,  1200,
    1489,  1566,  1201,  1641,  1486,  1550,  1551,  1644,  1815,  1888,
    1874,  1330,  1348,  1425,  1483,  1547,  1485,  1331,    60,    61,
      62,    63,    64,    65,    66,    67,   783,   119,   120,   121,
    1208,  1004,   122,  1349,  1568,  1679,  1772,  1567,  1491,  1350,
      68,    69,   123,   124,   335,  1011,  1012,   336,  1234,  1013,
     707,    70,   125,    71,   126,   127,   128,   516
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     198,   572,   230,   679,   771,   644,   647,   401,   402,   308,
     445,   418,   920,   319,   452,   327,  1233,   601,  1036,   334,
    1035,  1391,   348,   353,  1077,   798,  1109,   799,  1357,   801,
     802,  1572,   397,  1266,  1268,  1270,  1271,  1230,   797,   633,
    1573,  1574,  1575,  1081,   641,  1386,   411,  1516,  1523,  1526,
     412,   554,   398,   399,   424,   555,   832,   833,   660,   199,
     413,   398,   399,   551,   398,   399,   943,   671,   200,   674,
     576,   231,   577,   578,   579,  -330,   680,   411,   554,   683,
    1366,   412,   555,   934,  -330,  -330,  -330,  -330,  1216,   554,
     554,   413,  1768,   555,   555,   792,  1211,   914,  1580,   921,
     960,   709,  1552,   711,   354,  1700,   233,  1406,     1,   556,
     557,   558,   559,   355,  -329,  1769,   666,   554,   622,  1757,
    1217,   555,  1092,  -329,  -329,  -329,  -329,  1216,   139,  1230,
     518,   519,   520,   521,   522,   398,   399,   556,   557,   558,
     559,   960,   984,  1581,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   554,  1102,   532,   422,   555,  1213,  1217,
    1582,   576,   427,   577,   578,   579,   865,   440,   441,   442,
     173,   443,   439,   614,  1006,   616,   809,  1415,   565,   695,
     518,   519,   520,   521,   522,   570,   570,   206,   207,  1218,
     632,   146,   366,   380,   523,   524,   525,   526,   527,   528,
     529,   530,   531,  1448,   554,   532,  1570,   554,   555,   554,
    1758,   555,   830,   555,  1449,   831,   649,   600,   970,   623,
     518,   519,   520,   521,   522,   650,   388,   234,  1218,   556,
     557,   558,   559,   769,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   961,    72,   532,   643,   440,   441,   442,
    1081,   443,   784,   418,   546,   418,   554,   418,   418,   147,
     555,   780,  1416,   781,   782,   221,   785,   787,  1553,   789,
     790,  1219,  1220,  1221,  1222,  1223,  1224,  1225,   370,   682,
    1398,  1683,   222,   636,   961,  1580,   580,   371,  1214,  1554,
     917,  1099,  1496,  1226,   554,  1656,  1227,   613,   555,  1700,
    1354,  1230,   646,   518,   519,   520,   521,   522,   715,   667,
    1219,  1220,  1221,  1222,  1223,  1224,  1225,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   734,  1565,   532,  1650,
    1581,   935,  1226,   948,   949,  1227,  1770,   395,   159,   870,
    1091,  1407,  1555,  1459,   944,  1461,  1736,  1582,  1463,   160,
    1466,  1468,  1103,   740,   518,   519,   520,   521,   522,   916,
     971,   954,   915,  1573,  1574,  1575,  1081,  1283,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   204,   381,   532,
    1771,   212,   423,  1775,  1442,  1640,   554,   396,   936,   939,
     555,   205,   637,   586,  1109,  1787,   566,   800,   950,   741,
     952,   720,   810,   805,   223,  1678,   556,   557,   558,   559,
     224,   815,   816,   817,   818,   819,  1072,   972,   638,   225,
    1073,  1008,   977,  1009,   979,   617,   983,   828,   985,  1776,
    1358,   988,   989,   990,   567,   568,   993,   227,  1325,  1392,
     560,   996,  1021,  1393,   997,   552,  1078,  1499,   564,  1576,
     201,   835,  1779,  1577,   836,   414,   834,  1005,   213,   642,
     561,   415,  1548,  1387,   867,  1517,  1524,  1527,  1230,   425,
    1651,  1557,   214,  1593,  1872,  1017,  1018,  1019,  1595,   581,
    1596,   962,  1642,  1598,   595,   226,   414,   561,  1021,  1643,
     228,   793,   415,  -330,   388,   356,   554,  -330,   561,   561,
     555,   837,   838,   839,   840,   841,   842,   843,   844,   845,
     846,   847,   848,   849,   850,  1058,   556,   557,   558,   559,
     786,  1230,  1316,  1809,   570,  1810,   561,   206,   207,  1137,
     872,   866,  -329,  1811,  1401,  1812,  -329,   880,   518,   519,
     520,   521,   522,   388,   871,   750,   232,   823,  1336,  1332,
    1333,   824,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   640,   561,   532,   883,   554,   129,   130,   922,   555,
     581,  1816,  1817,  1652,  1499,   922,   444,  1724,   237,   922,
     603,  1686,  1334,   133,  1687,   556,   557,   558,   559,   398,
     399,   928,   131,   941,   942,  1230,  1230,  1263,   947,  1719,
    1720,  1264,   364,  1032,   611,   518,   519,   520,   521,   522,
     963,   359,   965,   561,  1185,   968,   561,   360,   561,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   751,  1107,
     532,   440,   441,   442,  1081,   443,  1573,  1574,  1575,  1081,
     698,  1063,   362,   980,   369,  1719,  1720,   389,   999,   445,
     445,  1384,  1793,   229,  1794,  1385,  1082,   383,  1051,   452,
    1053,   605,   606,   374,  1175,   561,  1163,   904,   238,   372,
     981,   982,  1015,   239,  1016,  1253,   384,   518,   519,   520,
     521,   522,   215,  1020,   672,  1389,   387,  1216,   403,  1390,
    1119,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     752,   216,   532,   561,   673,   388,  1136,  1138,   554,   699,
    1230,   861,   555,   404,  1144,   753,  1146,   240,  1725,  1217,
     390,  1514,   554,   405,  1067,  1515,   555,   754,   556,   557,
     558,   559,  1212,   376,   377,  1241,   206,   207,  1242,   700,
    1424,  1244,   556,   557,   558,   559,    73,   406,   701,   518,
     519,   520,   521,   522,   530,   531,  1057,   217,   532,   378,
     241,   407,  1112,   523,   524,   525,   526,   527,   528,   529,
     530,   531,  1785,   408,   532,  1068,   554,    74,  1721,  1093,
     555,   554,  1503,   937,   358,   555,    75,   361,  1218,    76,
     608,   905,   906,   907,   862,   561,   556,   557,   558,   559,
      77,   556,   557,   558,   559,  1074,  1608,  1075,   409,  1878,
     129,   130,  1041,    78,  1722,  1052,   410,  1054,   554,  1055,
    1056,  1726,   555,    79,  1765,   419,  1124,  1609,   218,    80,
     421,  1519,   629,   630,   863,  1520,   131,  1021,   556,   557,
     558,   559,   664,   665,  1294,   929,  1895,  1504,  1505,   930,
     864,   242,   702,   703,   704,   705,   877,   878,   879,    81,
    1766,    82,    83,   518,   519,   520,   521,   522,  1106,    84,
    1219,  1220,  1221,  1222,  1223,  1224,  1225,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   656,   657,   532,  1707,
    1184,  1300,  1226,   689,   690,  1227,  1126,  1127,   420,  1207,
     428,  1131,   429,   418,  1506,   561,    85,    86,   391,   430,
    1507,  1042,  1708,  1530,  1709,  1531,   376,   377,    87,  1710,
     857,   858,   392,   393,  1150,  1151,   431,  1043,  1153,   432,
    1155,  1156,   544,  1158,  1711,   433,   243,  1162,   548,  1344,
     244,    88,   549,  1532,    89,   873,   874,  1610,  1611,   140,
     141,   144,   145,  1335,  1337,   569,  1176,   603,   573,  1069,
    1345,   203,  1187,   608,   142,   143,   584,  1351,   518,   519,
     520,   521,   522,   574,   561,   587,  1355,  1805,  1712,   875,
     876,   604,   523,   524,   525,   526,   527,   528,   529,   530,
     531,  1364,   589,   532,   590,   245,   398,   399,  1007,   246,
     398,   399,  1282,   169,  1021,   170,   171,   172,   173,   174,
     175,  1024,  1025,   247,   591,  1299,   592,   176,   177,   825,
     178,  1823,   179,   594,  1044,   596,  1071,  1027,  1028,   938,
    1431,  1533,  1534,   597,  1090,  1535,  1536,  1304,   605,   606,
     444,  1537,  1340,  1095,   858,  1576,   805,   597,   908,   607,
    1257,  1258,  1259,   599,  1260,   169,  1261,   170,   171,   172,
     173,   174,   175,  1838,   615,  1272,  1286,   597,  1324,   176,
     177,  1274,   178,   620,   179,  1305,   618,  1868,  1869,  1870,
    1871,  1245,   619,  1247,   367,   368,   624,   518,   519,   520,
     521,   522,   621,  1301,   625,  1326,  -329,  1428,  1262,  1421,
    1422,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     180,   626,   532,  1419,  1420,   627,   181,   561,   628,  1287,
    1288,  1289,   631,   169,   634,   170,   171,   172,   173,   174,
     175,   561,   518,   519,   520,   521,   522,   176,   177,   635,
     178,   639,   179,  1603,  1604,  1327,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   206,   207,   532,  1530,  1188,
     648,   772,   180,  1704,  1705,  1189,    90,   608,   181,  1352,
    1381,  1857,  1858,  1859,  1860,  1861,   651,   773,  1356,   653,
     208,   182,   183,  1800,  1801,   561,  1482,  1045,  1532,   652,
     561,   209,  1306,   654,  1307,   655,  1308,  1309,  1543,  1371,
    1310,  1558,  1538,   658,   133,  1361,  1806,  1807,   661,  1362,
    1363,  1452,  1453,   663,   723,  1368,   812,   813,   184,   185,
     434,   435,   436,   437,  1190,   659,   662,   561,   668,   669,
     180,  1046,   675,   182,   183,   186,   181,   676,   187,   670,
     134,   677,   678,   188,   774,  1382,   681,  1383,   135,   136,
     137,   684,   161,   685,  1047,  1862,  1863,  1864,  1865,  1866,
     686,  1409,   687,   688,   691,   724,   725,   692,   694,  1048,
     184,   185,   434,   435,   436,   437,   775,   776,   726,   727,
     693,   728,  1445,   696,   777,   697,  1559,   186,   706,   708,
     187,   710,   712,   713,  1601,   188,  1426,  1427,  1049,  1050,
    1429,   182,   183,   714,   716,   717,   718,  1615,  1434,   719,
     721,  1435,   722,   731,  1606,  1645,   162,  1647,   163,   164,
    1578,   778,  1475,   733,   745,   735,   736,   737,   738,   518,
     519,   520,   521,   522,  1549,   739,  1549,   744,   184,   185,
    1439,   805,  1441,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   746,   748,   532,   186,   749,   788,   187,   779,
     791,   795,   796,   188,  1455,   803,   808,   165,   166,   167,
     168,   804,   811,   814,   532,  1560,  1561,  1562,   820,  1563,
     821,   822,  1717,   829,   859,  1062,  1762,  1728,  1191,  1730,
     169,   860,   170,   171,   172,   173,   174,   175,   911,   869,
     884,   913,  1492,   910,   176,   177,  1265,   178,   927,   179,
    1192,   932,  1193,   933,   189,   940,   945,  1194,   953,  1195,
     946,   190,   951,  1196,  1197,   955,  1761,   956,  1763,   957,
    1501,  1502,   851,  1368,   518,   519,   520,   521,   522,   958,
     964,   974,   966,   967,   969,  1600,   973,  1564,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   852,   976,   532,
     978,   986,   975,   987,  1198,   853,   189,   991,   992,   236,
     854,   855,   856,   190,   994,   998,  1001,  1814,   248,  1002,
    1797,  1798,  1799,   265,  1003,   266,  1010,   309,  1014,   310,
    1824,   323,  1026,   328,  1029,   329,  1030,   180,  1031,   570,
    1607,  1033,  1038,   181,  1070,  1578,  1034,  1578,  1039,  1828,
    1829,  1037,  1059,  1831,  1064,  1060,  1061,  1646,  1065,  1076,
    1832,  1833,  1649,  1066,  1653,  1654,  1079,  1657,  1086,  1085,
    1105,  1088,  1216,  1114,   189,  -489,  1839,  1873,  1097,  1098,
    1100,   190,  1843,  1104,  1844,  1845,   169,  1094,   170,   171,
     172,   173,   174,   175,  1113,  1116,  1117,  1128,  1148,  1684,
     176,   177,  1269,   178,  1217,   179,   148,   149,   182,   183,
    1688,  1689,  1690,  1691,  1129,  1130,  1132,  1133,  1134,  1135,
    1140,  1715,  1141,  1142,   150,  1879,  1880,  1881,  1876,  1143,
    1145,  1731,  1732,  1733,  1147,  1735,  1737,  1152,  1882,   151,
    1748,  1235,  1239,  1154,  1157,   184,   185,  1752,   152,  1159,
     153,   154,  1160,  1161,  1890,  1891,  1892,  1893,  1164,  1754,
    1755,  1165,   186,  1756,  1166,   187,  1760,  1167,  1168,  1169,
     188,  1170,  1171,  1218,  1172,  1240,  1243,   169,  1780,   170,
     171,   172,   173,   174,   175,  1173,  1174,  1177,  1202,  1209,
    1210,   176,   177,   180,   178,  1246,   179,  1248,  1249,   181,
    1250,  1255,  1256,  1251,  1252,   570,   570,   570,  1273,  1279,
    1280,  1802,  1296,  1281,  1298,  1302,  1297,   155,  1339,  1303,
    1313,  1314,  1818,  1819,  1820,  1821,  1822,   169,  1315,   170,
     171,   172,   173,   174,   175,  1317,  1318,  1319,  1826,  1320,
    1827,   176,   177,  1460,   178,  1321,   179,  1322,  1323,  1329,
    1328,  1346,  1353,  1830,  1359,  1219,  1220,  1221,  1222,  1223,
    1224,  1225,  1347,  1834,   182,   183,  1360,  1367,  1835,  1836,
    1837,  1372,  1373,  1374,  1375,  1376,  1388,  1226,  1840,  1395,
    1227,  1841,  1842,  1394,   180,  1397,  1080,  1400,  1414,  1413,
     181,  1410,  1411,  1404,  1412,   518,   519,   520,   521,   522,
    1417,   184,   185,  1418,  1423,  1430,   156,  1432,  1846,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   186,  1433,
     532,   187,  1438,  1446,  1447,  1436,   188,  1451,  1454,  1464,
    1450,  1469,  1458,  1462,   180,  1470,  1474,  1476,  1478,  1479,
     181,   189,  1480,  1509,  1510,  1484,  1490,  1521,   190,  1494,
    1512,  1513,  1518,  1528,  1522,   182,   183,   169,  1525,   170,
     171,   172,   173,   174,   175,   157,  1544,  1569,  1571,  1587,
    1591,   176,   177,  1465,   178,  1588,   179,  1589,  1590,   158,
    1592,  1594,  1597,   169,  1602,   170,   171,   172,   173,   174,
     175,  1096,   184,   185,  1599,  1605,  1613,   176,   177,  1467,
     178,  1614,   179,  1648,  1655,   182,   183,  1658,  1680,   186,
    1681,  1685,   187,  1692,  1693,  1694,  1695,   188,   533,   534,
     535,   536,   537,   538,   539,   540,   541,  1696,  1697,  1530,
    1698,   169,  1701,   170,   171,   172,   173,   174,   175,  1702,
    1703,  1706,   184,   185,  1216,   176,   177,  1714,   178,  1727,
     179,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,   186,
    1716,  1718,   187,  1729,   180,  1734,  1747,   188,  1746,  1750,
     181,  1749,  1751,  1759,  1753,  1764,  1217,  1773,  1774,  1777,
    1497,  1778,  1782,  1783,  1795,  1796,  1781,  1803,  1825,  1813,
     180,   518,   519,   520,   521,   522,   181,   189,  1875,  1847,
    1848,  1849,  1877,  1850,   190,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   868,  1851,   532,   885,   886,   887,
     888,   889,   890,   891,   892,  1852,   893,   894,   895,   896,
     897,   898,  1854,  1855,  1856,   182,   183,  1867,   180,  1883,
    1884,  1885,  1886,  1894,   181,  1218,  1089,  1887,  1896,   518,
     519,   520,   521,   522,   732,  1889,   612,  1767,  1285,  1437,
    1853,   182,   183,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   184,   185,   532,  1237,  1238,   747,  1275,  1399,
    1111,   902,  1682,  1083,  1786,   438,  1084,  -484,   189,   186,
    1788,  1365,   187,  1508,  1087,   190,  1440,   188,   184,   185,
    1292,  1254,  1529,  1471,  1481,  1488,     0,  1149,  1546,   182,
     183,  1215,     0,     0,     0,   186,     0,     0,   187,     0,
       0,     0,     0,   188,     0,     0,     0,  1219,  1220,  1221,
    1222,  1223,  1224,  1225,     0,     0,     0,     0,   189,   518,
     519,   520,   521,   522,     0,   190,   184,   185,     0,  1226,
       0,     0,  1227,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   186,   532,     0,   187,     0,     0,     0,
       0,   188,   518,   519,   520,   521,   522,     0,     0,     0,
       0,  1228,     0,     0,     0,     0,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,     0,   532,     0,   518,
     519,   520,   521,   522,     0,     0,     0,     0,     0,     0,
       0,     0,  1101,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,     0,   532,   518,   519,   520,   521,   522,
       0,     0,     0,  1108,     0,     0,     0,     0,     0,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,     0,
     532,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   518,   519,   520,   521,   522,     0,   189,     0,
       0,     0,     0,     0,     0,   190,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,     0,   532,   518,   519,
     520,   521,   522,     0,   189,     0,     0,     0,     0,     0,
       0,   190,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,     0,   532,   518,   519,   520,   521,   522,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,     0,   532,
       0,     0,   189,   518,   519,   520,   521,   522,     0,   190,
       0,     0,     0,  1229,     0,     0,     0,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,     0,   532,   518,
     519,   520,   521,   522,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,     0,   532,   518,   519,   520,   521,   522,
       0,     0,     0,     0,     0,     0,     0,     0,  1377,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,     0,
     532,   518,   519,   520,   521,   522,     0,   924,     0,     0,
       0,     0,     0,     0,     0,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,     0,   532,     0,     0,     0,
       0,     0,     0,   518,   519,   520,   521,   522,     0,     0,
       0,     0,     0,     0,     0,     0,  1378,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,     0,   532,   518,
     519,   520,   521,   522,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,     0,   532,   518,   519,   520,   521,   522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,     0,
     532,     0,   518,   519,   520,   521,   522,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,  1379,   532,   518,   519,
     520,   521,   522,   455,     0,     0,     0,     0,     0,     0,
       0,     0,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,     0,   532,     0,     0,     0,     0,     0,  1380,
     518,   519,   520,   521,   522,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,     0,   532,  1396,   885,   886,   887,
     888,   889,   890,   891,   892,     0,   893,   894,   895,   896,
     897,   898,     0,     0,     0,     0,     0,     0,     0,     0,
     456,   457,  1456,     0,     0,     0,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,     0,     0,     0,     0,  1659,  1457,
       0,     0,     0,     0,   249,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   249,     0,     0,     0,   486,     0,
       0,     0,  1660,  1661,     0,  1511,     0,     0,     0,     0,
       0,   337,   338,   339,     0,   340,   341,     0,   342,     0,
       0,     0,   343,  1662,   251,   344,     0,  -490,  -490,  -490,
       0,  1784,     0,     0,   251,     0,     0,   487,     0,     0,
       0,  -490,  -490,  -490,  -490,  -490,   528,   529,   530,   531,
       0,   249,   532,     0,   252,     0,     0,     0,   253,   254,
    1789,     0,   256,   257,   252,     0,   258,     0,   253,   254,
     259,  1120,   256,   257,     0,  1530,   258,  1663,     0,     0,
     259,     0,     0,     0,     0,     0,  1790,     0,     0,   311,
       0,   251,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,     0,     0,  1664,  1532,     0,  1444,   260,     0,
       0,     0,  1791,   261,     0,     0,     0,     0,   260,     0,
       0,   252,     0,   261,     0,   253,   254,     0,     0,   256,
     257,     0,     0,   258,     0,     0,     0,   259,  1792,   518,
     519,   520,     0,   497,   498,   499,   500,   501,   502,   503,
     504,   505,     0,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,     0,   532,     0,     0,     0,  1443,   506,
     507,     0,     0,     0,     0,   260,     0,     0,     0,     0,
     261,   249,     0,     0,   508,     0,     0,     0,     0,     0,
       0,     0,  1665,   455,  1493,  1666,  1667,     0,     0,     0,
       0,   330,     0,  1668,     0,   509,   510,   511,   512,   517,
       0,  1121,  1122,     0,   518,   519,   520,   521,   522,     0,
    1495,   251,     0,     0,     0,     0,     0,     0,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,     0,   532,
       0,     0,     0,     0,     0,     0,     0,  1585,     0,     0,
       0,   252,     0,  1669,     0,   253,   254,     0,     0,   256,
     257,     0,     0,   258,     0,     0,     0,   259,     0,     0,
     456,   457,     0,  1586,   513,   514,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,     0,   260,     0,   249,     0,     0,
     261,     0,     0,   518,   519,   520,   521,   522,     0,     0,
       0,  1670,     0,     0,   331,   249,     0,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,  1671,   532,   249,
       0,     0,  1672,  1673,   267,  1674,  1675,   251,  1676,     0,
       0,   312,     0,     0,   268,     0,   313,   314,   315,   269,
       0,     0,     0,     0,  1677,  1178,   345,   487,     0,     0,
       0,     0,     0,   270,     0,     0,  1123,   252,     0,   251,
       0,   253,   254,   249,  1203,   256,   257,     0,     0,   258,
     316,     0,     0,   259,     0,   252,     0,   317,     0,   253,
     254,     0,     0,   256,   257,  1179,     0,   258,     0,   252,
       0,   259,     0,   253,   254,   271,   272,   256,   257,     0,
       0,   258,   273,   251,     0,   259,     0,     0,     0,   274,
       0,   260,   275,   318,   276,     0,   261,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   249,   332,   260,
       0,     0,     0,   252,   261,     0,     0,   253,   254,  1616,
       0,   256,   257,   260,     0,   258,     0,   250,   261,   259,
       0,     0,     0,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   277,     0,   278,     0,     0,   251,     0,     0,
       0,     0,     0,   279,     0,     0,     0,     0,     0,   506,
     507,     0,     0,     0,     0,     0,     0,   260,     0,     0,
       0,     0,   261,     0,   508,     0,     0,   252,     0,     0,
       0,   253,   254,     0,   255,   256,   257,     0,     0,   258,
       0,   280,  1530,   259,   608,   509,   510,   511,   512,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   281,
     249,     0,     0,     0,     0,     0,   282,   283,     0,   284,
       0,     0,  1532,   333,   285,   286,     0,   287,   288,     0,
     289,   260,     0,   290,   291,  1617,   261,     0,     0,   349,
       0,     0,     0,     0,     0,     0,     0,   292,   293,  1618,
     251,     0,   294,     0,   295,   296,     0,   297,     0,     0,
       0,     0,   298,     0,   513,   514,   299,   300,     0,   301,
     302,     0,   303,   304,   305,     0,     0,     0,   306,     0,
     252,  1180,  1181,  1182,   253,   254,     0,     0,   256,   257,
       4,     0,   258,     0,     0,     0,   259,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1204,     0,     0,  1619,
       0,     0,  1620,  1621,     0,     5,     6,   756,     0,   350,
    1622,     0,     0,     0,     0,     7,  1205,     0,     0,     0,
     324,     0,   398,   399,   260,     0,     0,     0,     0,   261,
       0,   885,   886,   887,   888,   889,   890,   891,   892,  1206,
     893,   894,   895,   896,   897,   898,     0,     0,     0,   757,
       0,     0,     0,     0,     0,     0,     0,  1183,     0,     0,
    1623,     0,     0,  1624,     0,     0,  1625,     0,     0,     0,
       8,   307,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   325,     0,
     758,     0,     0,     0,     0,  1626,     0,  1627,     0,  1628,
    1629,  1630,  1631,  1632,  1633,     0,     9,     0,     0,    10,
    1634,    11,     0,  1635,     0,   326,  1636,     0,    12,     0,
      13,     0,   759,     0,     0,    14,    15,    16,  1637,   760,
     761,     0,    17,    18,    19,     0,  1638,     0,     0,     0,
       0,     0,   762,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   763,
     764,   765,   766,     0,   767,   768,     0,     0,     0,     0,
       0,  1639,     0,     0,     0,     0,     0,     0,     0,   262,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   608,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,   351
};

static const yytype_int16 yycheck[] =
{
      17,   222,    87,   312,   385,   283,   284,   159,   160,   114,
     190,   169,   602,   118,   190,   120,  1013,   254,   766,   124,
     761,     7,   127,   128,     7,   411,   911,   413,    22,   415,
     416,     6,   158,  1076,  1077,  1078,  1079,  1013,     7,   276,
      15,    16,    17,    18,   281,     7,    15,     7,     7,     7,
      19,    15,    18,    19,    15,    19,    27,    28,   295,    36,
      29,    18,    19,    45,    18,    19,    51,   304,    45,   306,
      15,    88,    17,    18,    19,     6,   313,    15,    15,   316,
    1230,    19,    19,    80,    15,    16,    17,    18,    19,    15,
      15,    29,   127,    19,    19,    30,  1008,   163,  1500,    36,
      42,   338,   188,   340,    36,  1602,    19,    31,     4,    35,
      36,    37,    38,    45,     6,   150,   122,    15,   182,   323,
      51,    19,   863,    15,    16,    17,    18,    19,     3,  1105,
       8,     9,    10,    11,    12,    18,    19,    35,    36,    37,
      38,    42,   664,  1500,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    15,    19,    33,    28,    19,   256,    51,
    1500,    15,   179,    17,    18,    19,   547,    15,    16,    17,
      18,    19,   189,   258,   696,   260,    28,   247,   214,   331,
       8,     9,    10,    11,    12,   221,   222,    19,    20,   120,
     275,     3,   141,     3,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    22,    15,    33,  1497,    15,    19,    15,
     414,    19,   429,    19,    33,   432,   273,   253,   137,   283,
       8,     9,    10,    11,    12,   282,    19,   140,   120,    35,
      36,    37,    38,   385,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   185,     0,    33,   282,    15,    16,    17,
      18,    19,    45,   411,   203,   413,    15,   415,   416,   163,
      19,   387,   332,   389,   390,    50,   392,   393,   354,   395,
     396,   202,   203,   204,   205,   206,   207,   208,    36,   315,
    1277,  1572,    67,   189,   185,  1687,   140,    45,   386,   375,
     599,   881,  1442,   224,    15,   157,   227,   129,    19,  1796,
    1212,  1277,   185,     8,     9,    10,    11,    12,   344,   315,
     202,   203,   204,   205,   206,   207,   208,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   362,  1489,    33,   127,
    1687,   328,   224,   259,   260,   227,   371,   146,   163,   560,
     862,   265,   428,  1386,   329,  1388,   157,  1687,  1391,   163,
    1393,  1394,   217,   130,     8,     9,    10,    11,    12,   596,
     279,   639,   428,    15,    16,    17,    18,  1115,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   193,   188,    33,
     415,    68,   254,   362,  1360,  1547,    15,   196,   625,   626,
      19,    19,   298,   229,  1279,  1686,    20,   414,   635,   176,
     637,   350,   254,   420,    81,  1567,    35,    36,    37,    38,
      19,   428,   429,   430,   431,   432,   425,   654,   324,   117,
     429,   699,   659,   701,   661,   261,   663,   444,   665,   408,
     424,   668,   669,   670,    58,    59,   673,    86,  1179,   425,
      69,   678,   720,   429,   681,   427,   429,  1444,   213,   424,
     427,   429,   377,   428,   432,   424,   427,   694,   145,   423,
     424,   430,   428,   425,   549,   425,   425,   425,  1444,   430,
     268,   428,   159,  1516,   428,   712,   713,   714,  1521,   424,
    1523,   423,   375,  1526,   249,    19,   424,   424,   766,   382,
     165,   426,   430,   424,    19,   427,    15,   428,   424,   424,
      19,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   793,    35,    36,    37,    38,
      45,  1497,   423,   140,   560,   142,   424,    19,    20,   427,
     566,   548,   424,   140,  1282,   142,   428,   573,     8,     9,
      10,    11,    12,    19,   561,     3,    19,   425,   354,   354,
     355,   429,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    80,   424,    33,   581,    15,    19,    20,   604,    19,
     424,   379,   380,   371,  1571,   611,   424,   127,   427,   615,
      45,   426,   387,    20,   429,    35,    36,    37,    38,    18,
      19,   608,    45,   629,   630,  1571,  1572,   425,   634,   180,
     181,   429,    20,   755,    69,     8,     9,    10,    11,    12,
     646,     3,   648,   424,   995,   651,   424,     3,   424,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    86,   907,
      33,    15,    16,    17,    18,    19,    15,    16,    17,    18,
     207,   429,    67,   279,     3,   180,   181,   123,   684,   829,
     830,   425,  1695,   145,  1697,   429,   424,     3,   784,   835,
     786,   126,   127,    86,   423,   424,   975,    42,    73,   427,
     306,   307,   708,    78,   710,  1061,     3,     8,     9,    10,
      11,    12,    43,   719,   266,   425,   270,    19,     3,   429,
     927,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     158,    62,    33,   424,   286,    19,   943,   944,    15,   276,
    1686,     3,    19,     3,   951,   173,   953,   122,   268,    51,
     196,   425,    15,     3,   429,   429,    19,   185,    35,    36,
      37,    38,  1010,    19,    20,  1044,    19,    20,  1047,   306,
    1330,  1050,    35,    36,    37,    38,     3,     3,   315,     8,
       9,    10,    11,    12,    29,    30,   792,   118,    33,    45,
     165,     3,   914,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   424,     3,    33,   429,    15,    34,   359,   864,
      19,    15,   126,    76,   134,    19,    43,   137,   120,    46,
     255,   166,   167,   168,    86,   424,    35,    36,    37,    38,
      57,    35,    36,    37,    38,   822,   127,   824,     3,  1852,
      19,    20,   782,    70,   395,   785,     3,   787,    15,   789,
     790,   371,    19,    80,   359,    30,   931,   148,   189,    86,
     254,   425,   286,   287,   126,   429,    45,  1115,    35,    36,
      37,    38,    86,    87,  1122,   611,  1889,   191,   192,   615,
     142,   256,   419,   420,   421,   422,    39,    40,    41,   116,
     395,   118,   119,     8,     9,    10,    11,    12,   904,   126,
     202,   203,   204,   205,   206,   207,   208,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   296,   297,    33,   117,
     995,  1128,   224,   402,   403,   227,   932,   933,   424,  1004,
     424,   937,   424,  1061,   248,   424,   163,   164,   384,   424,
     254,     3,   140,   139,   142,   141,    19,    20,   175,   147,
     428,   429,   398,   399,   960,   961,   424,    19,   964,   424,
     966,   967,    15,   969,   162,   424,   341,   973,    22,   389,
     345,   198,    63,   169,   201,    60,    61,   268,   269,     7,
       8,     9,    10,  1190,  1191,   423,   992,    45,   182,   429,
    1197,    19,   998,   255,   173,   174,    19,  1204,     8,     9,
      10,    11,    12,   171,   424,   423,  1213,  1709,   206,    60,
      61,    69,    22,    23,    24,    25,    26,    27,    28,    29,
      30,  1228,   140,    33,    19,   400,    18,    19,    20,   404,
      18,    19,    20,    13,  1282,    15,    16,    17,    18,    19,
      20,   428,   429,   418,   427,   322,   427,    27,    28,    29,
      30,   260,    32,   427,   116,   323,   429,   428,   429,   322,
    1339,   257,   258,    19,    20,   261,   262,   174,   126,   127,
     424,   267,  1194,   428,   429,   424,  1063,    19,   423,   137,
    1067,  1068,  1069,   117,  1071,    13,  1073,    15,    16,    17,
      18,    19,    20,   260,    69,  1082,    81,    19,    20,    27,
      28,  1088,    30,   427,    32,   212,   423,  1809,  1810,  1811,
    1812,  1051,   423,  1053,   142,   143,   327,     8,     9,    10,
      11,    12,   427,  1129,   323,  1180,   428,  1334,   429,   428,
     429,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     120,    81,    33,   338,   339,   423,   126,   424,    20,   134,
     135,   136,   284,    13,    69,    15,    16,    17,    18,    19,
      20,   424,     8,     9,    10,    11,    12,    27,    28,    85,
      30,   168,    32,   259,   260,  1181,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    19,    20,    33,   139,   123,
      76,     3,   120,   150,   151,   129,   423,   255,   126,  1205,
     429,   150,   151,   152,   153,   154,    76,    19,  1214,   278,
      44,   191,   192,   150,   151,   424,  1423,   279,   169,   271,
     424,    55,   329,    87,   331,   282,   333,   334,  1476,  1235,
     337,   182,   428,   296,    20,  1222,   148,   149,   303,  1226,
    1227,  1374,  1375,   310,    79,  1232,   424,   425,   228,   229,
     230,   231,   232,   233,   188,   300,   305,   424,    87,   318,
     120,   323,   423,   191,   192,   245,   126,   427,   248,   316,
      56,   427,   383,   253,    86,  1262,   116,  1264,    64,    65,
      66,   117,    79,   423,   346,   150,   151,   152,   153,   154,
     427,  1297,   427,    86,   423,   130,   131,   427,   323,   361,
     228,   229,   230,   231,   232,   233,   118,   119,   143,   144,
     427,   146,   427,    86,   126,   423,   267,   245,   427,    86,
     248,    76,    79,    81,  1531,   253,  1332,  1333,   390,   391,
    1336,   191,   192,    85,   423,   423,   423,  1544,  1344,    76,
     423,  1347,   423,     3,  1535,  1552,   143,  1554,   145,   146,
    1500,   163,  1407,     3,    19,     3,     3,     3,     3,     8,
       9,    10,    11,    12,  1486,     3,  1488,     3,   228,   229,
    1357,  1358,  1359,    22,    23,    24,    25,    26,    27,    28,
      29,    30,     3,     3,    33,   245,     3,     3,   248,   201,
       3,   183,   183,   253,  1381,    14,    27,   194,   195,   196,
     197,    15,    28,    30,    33,   356,   357,   358,    19,   360,
      15,   429,  1619,     7,     3,   425,  1664,  1624,   352,  1626,
      13,     3,    15,    16,    17,    18,    19,    20,   424,   423,
     423,    19,  1438,   423,    27,    28,    29,    30,   138,    32,
     374,    76,   376,    76,   424,   423,   423,   381,   176,   383,
     423,   431,   308,   387,   388,   423,  1663,   423,  1665,   423,
    1447,  1448,   211,  1450,     8,     9,    10,    11,    12,    31,
     185,   423,    76,    76,    76,  1530,    76,   428,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   236,   423,    33,
     423,   423,   117,   423,   428,   244,   424,   423,   185,    97,
     249,   250,   251,   431,   423,    69,    19,  1714,   106,   423,
    1701,  1702,  1703,   111,   423,   113,   276,   115,   423,   117,
    1727,   119,     3,   121,     3,   123,    19,   120,    15,  1535,
    1536,    19,     3,   126,   425,  1685,    19,  1687,    20,  1746,
    1747,    19,    15,  1750,   425,    15,    15,  1553,   254,   429,
    1757,  1758,  1558,    28,  1560,  1561,   429,  1563,    18,    15,
     427,   424,    19,    28,   424,   425,  1773,  1815,    20,   423,
     423,   431,  1779,   423,  1781,  1782,    13,   423,    15,    16,
      17,    18,    19,    20,   423,   429,   133,    81,    19,  1576,
      27,    28,    29,    30,    51,    32,   145,   146,   191,   192,
    1587,  1588,  1589,  1590,    76,   423,   423,   423,   423,   423,
     423,  1617,   423,   423,   163,  1854,  1855,  1856,  1825,   423,
     423,  1627,  1628,  1629,   423,  1631,  1632,   423,  1867,   178,
    1636,    69,     3,   423,   423,   228,   229,  1643,   187,   423,
     189,   190,   423,   423,  1883,  1884,  1885,  1886,   423,  1655,
    1656,   423,   245,  1659,   423,   248,  1662,   423,   423,   423,
     253,   423,   423,   120,   423,     3,    15,    13,  1674,    15,
      16,    17,    18,    19,    20,   423,   423,   423,   423,   423,
     423,    27,    28,   120,    30,     3,    32,     3,     3,   126,
       3,    28,    28,   185,   185,  1701,  1702,  1703,   429,   423,
     425,  1707,   423,   183,   423,   423,   429,   256,   323,   423,
     423,   423,  1718,  1719,  1720,  1721,  1722,    13,   423,    15,
      16,    17,    18,    19,    20,   423,   423,   423,  1734,   423,
    1736,    27,    28,    29,    30,   423,    32,   423,   423,   423,
     191,   423,   423,  1749,    22,   202,   203,   204,   205,   206,
     207,   208,   392,  1759,   191,   192,   424,   423,  1764,  1765,
    1766,     3,     3,    15,    15,    28,   429,   224,  1774,    15,
     227,  1777,  1778,   429,   120,   428,   425,    15,    69,   340,
     126,   423,   423,   427,   423,     8,     9,    10,    11,    12,
     336,   228,   229,   335,   280,   427,   345,   427,  1785,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   245,   427,
      33,   248,    69,   423,    22,   427,   253,   423,    28,     7,
     429,   428,    29,    29,   120,   185,    19,   266,   423,   194,
     126,   424,   330,     3,     3,   427,   427,   424,   431,   425,
     425,   425,   425,    15,   425,   191,   192,    13,   425,    15,
      16,    17,    18,    19,    20,   404,   263,   425,   226,   424,
     423,    27,    28,    29,    30,   424,    32,   424,   424,   418,
      29,    29,     7,    13,   427,    15,    16,    17,    18,    19,
      20,   425,   228,   229,   423,   260,   427,    27,    28,    29,
      30,   423,    32,   423,   282,   191,   192,   423,   423,   245,
     428,     7,   248,   425,   425,   425,   429,   253,    46,    47,
      48,    49,    50,    51,    52,    53,    54,   425,   424,   139,
     425,    13,   261,    15,    16,    17,    18,    19,    20,   261,
     261,   148,   228,   229,    19,    27,    28,   323,    30,   318,
      32,   362,   363,   364,   365,   366,   367,   368,   369,   245,
     427,   378,   248,   396,   120,   282,   364,   253,   394,   362,
     126,   386,   423,    76,   423,   378,    51,   318,   386,    76,
     427,    76,   413,   423,   428,   423,   411,    20,   397,   428,
     120,     8,     9,    10,    11,    12,   126,   424,   377,   423,
     423,   423,   377,   423,   431,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   552,   425,    33,   209,   210,   211,
     212,   213,   214,   215,   216,   429,   218,   219,   220,   221,
     222,   223,   423,   423,   423,   191,   192,   423,   120,   423,
     423,   423,   423,   423,   126,   120,   858,   372,   425,     8,
       9,    10,    11,    12,   358,   429,   257,  1667,  1116,  1349,
    1796,   191,   192,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   228,   229,    33,  1025,  1028,   378,  1104,  1279,
     912,   583,  1571,   829,  1685,   189,   830,   423,   424,   245,
    1687,  1230,   248,  1450,   835,   431,  1358,   253,   228,   229,
    1121,  1063,  1471,  1403,  1422,  1433,    -1,   959,  1483,   191,
     192,  1012,    -1,    -1,    -1,   245,    -1,    -1,   248,    -1,
      -1,    -1,    -1,   253,    -1,    -1,    -1,   202,   203,   204,
     205,   206,   207,   208,    -1,    -1,    -1,    -1,   424,     8,
       9,    10,    11,    12,    -1,   431,   228,   229,    -1,   224,
      -1,    -1,   227,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,   245,    33,    -1,   248,    -1,    -1,    -1,
      -1,   253,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,   256,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   425,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,   425,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    11,    12,    -1,   424,    -1,
      -1,    -1,    -1,    -1,    -1,   431,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,     8,     9,
      10,    11,    12,    -1,   424,    -1,    -1,    -1,    -1,    -1,
      -1,   431,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
      -1,    -1,   424,     8,     9,    10,    11,    12,    -1,   431,
      -1,    -1,    -1,   428,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,    -1,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,    -1,
      -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   425,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,   425,    33,     8,     9,
      10,    11,    12,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,   425,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,   425,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,   219,   220,   221,
     222,   223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      82,    83,   425,    -1,    -1,    -1,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,    -1,    -1,    -1,    -1,    42,   425,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,   140,    -1,
      -1,    -1,    66,    67,    -1,   425,    -1,    -1,    -1,    -1,
      -1,    73,    74,    75,    -1,    77,    78,    -1,    80,    -1,
      -1,    -1,    84,    87,    86,    87,    -1,     8,     9,    10,
      -1,   425,    -1,    -1,    86,    -1,    -1,   179,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    46,    33,    -1,   116,    -1,    -1,    -1,   120,   121,
     425,    -1,   124,   125,   116,    -1,   128,    -1,   120,   121,
     132,   123,   124,   125,    -1,   139,   128,   141,    -1,    -1,
     132,    -1,    -1,    -1,    -1,    -1,   425,    -1,    -1,    84,
      -1,    86,   234,   235,    -1,   237,   238,   239,   240,   241,
     242,   243,    -1,    -1,   168,   169,    -1,   225,   170,    -1,
      -1,    -1,   425,   175,    -1,    -1,    -1,    -1,   170,    -1,
      -1,   116,    -1,   175,    -1,   120,   121,    -1,    -1,   124,
     125,    -1,    -1,   128,    -1,    -1,    -1,   132,   425,     8,
       9,    10,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,    -1,    -1,    -1,   423,   311,
     312,    -1,    -1,    -1,    -1,   170,    -1,    -1,    -1,    -1,
     175,    46,    -1,    -1,   326,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   256,     5,   423,   259,   260,    -1,    -1,    -1,
      -1,    66,    -1,   267,    -1,   347,   348,   349,   350,     3,
      -1,   263,   264,    -1,     8,     9,    10,    11,    12,    -1,
     423,    86,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,
      -1,   116,    -1,   317,    -1,   120,   121,    -1,    -1,   124,
     125,    -1,    -1,   128,    -1,    -1,    -1,   132,    -1,    -1,
      82,    83,    -1,   423,   416,   417,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,    -1,   170,    -1,    46,    -1,    -1,
     175,    -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,   385,    -1,    -1,   189,    46,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,   401,    33,    46,
      -1,    -1,   406,   407,    51,   409,   410,    86,   412,    -1,
      -1,   346,    -1,    -1,    61,    -1,   351,   352,   353,    66,
      -1,    -1,    -1,    -1,   428,    86,   428,   179,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,   428,   116,    -1,    86,
      -1,   120,   121,    46,   123,   124,   125,    -1,    -1,   128,
     385,    -1,    -1,   132,    -1,   116,    -1,   392,    -1,   120,
     121,    -1,    -1,   124,   125,   126,    -1,   128,    -1,   116,
      -1,   132,    -1,   120,   121,   122,   123,   124,   125,    -1,
      -1,   128,   129,    86,    -1,   132,    -1,    -1,    -1,   136,
      -1,   170,   139,   428,   141,    -1,   175,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,   313,   170,
      -1,    -1,    -1,   116,   175,    -1,    -1,   120,   121,    66,
      -1,   124,   125,   170,    -1,   128,    -1,    66,   175,   132,
      -1,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   189,    -1,   191,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,    -1,   311,
     312,    -1,    -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,
      -1,    -1,   175,    -1,   326,    -1,    -1,   116,    -1,    -1,
      -1,   120,   121,    -1,   123,   124,   125,    -1,    -1,   128,
      -1,   238,   139,   132,   255,   347,   348,   349,   350,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,
      46,    -1,    -1,    -1,    -1,    -1,   263,   264,    -1,   266,
      -1,    -1,   169,   428,   271,   272,    -1,   274,   275,    -1,
     277,   170,    -1,   280,   281,   182,   175,    -1,    -1,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   294,   295,   196,
      86,    -1,   299,    -1,   301,   302,    -1,   304,    -1,    -1,
      -1,    -1,   309,    -1,   416,   417,   313,   314,    -1,   316,
     317,    -1,   319,   320,   321,    -1,    -1,    -1,   325,    -1,
     116,   342,   343,   344,   120,   121,    -1,    -1,   124,   125,
      46,    -1,   128,    -1,    -1,    -1,   132,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   385,    -1,    -1,   256,
      -1,    -1,   259,   260,    -1,    71,    72,     3,    -1,   155,
     267,    -1,    -1,    -1,    -1,    81,   405,    -1,    -1,    -1,
     333,    -1,    18,    19,   170,    -1,    -1,    -1,    -1,   175,
      -1,   209,   210,   211,   212,   213,   214,   215,   216,   428,
     218,   219,   220,   221,   222,   223,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,    -1,    -1,
     317,    -1,    -1,   320,    -1,    -1,   323,    -1,    -1,    -1,
     136,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,    -1,
      86,    -1,    -1,    -1,    -1,   352,    -1,   354,    -1,   356,
     357,   358,   359,   360,   361,    -1,   172,    -1,    -1,   175,
     367,   177,    -1,   370,    -1,   428,   373,    -1,   184,    -1,
     186,    -1,   118,    -1,    -1,   191,   192,   193,   385,   125,
     126,    -1,   198,   199,   200,    -1,   393,    -1,    -1,    -1,
      -1,    -1,   138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   155,
     156,   157,   158,    -1,   160,   161,    -1,    -1,    -1,    -1,
      -1,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   341,    -1,    -1,    -1,    -1,
      -1,    -1,   428
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   434,   435,    46,    71,    72,    81,   136,   172,
     175,   177,   184,   186,   191,   192,   193,   198,   199,   200,
     341,   460,   461,   462,   463,   464,   465,   518,   519,   520,
     521,   523,   524,   525,   528,   531,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   626,   637,
     671,   672,   673,   674,   675,   676,   677,   678,   693,   694,
     704,   706,     0,     3,    34,    43,    46,    57,    70,    80,
      86,   116,   118,   119,   126,   163,   164,   175,   198,   201,
     423,   436,   449,   455,   458,   459,   468,   471,   474,   476,
     479,   481,   482,   484,   485,   492,   502,   503,   560,   562,
     572,   610,   613,   627,   632,   633,   636,   639,   640,   680,
     681,   682,   685,   695,   696,   705,   707,   708,   709,    19,
      20,    45,   558,    20,    56,    64,    65,    66,   466,     3,
     558,   558,   173,   174,   558,   558,     3,   163,   145,   146,
     163,   178,   187,   189,   190,   256,   345,   404,   418,   163,
     163,    79,   143,   145,   146,   194,   195,   196,   197,    13,
      15,    16,    17,    18,    19,    20,    27,    28,    30,    32,
     120,   126,   191,   192,   228,   229,   245,   248,   253,   424,
     431,   577,   589,   594,   597,   598,   599,   601,   603,    36,
      45,   427,   547,   558,   193,    19,    19,    20,    44,    55,
     446,   451,    68,   145,   159,    43,    62,   118,   189,   456,
     457,    50,    67,    81,    19,   117,    19,    86,   165,   145,
     446,   603,    19,    19,   140,   486,   486,   427,    73,    78,
     122,   165,   256,   341,   345,   400,   404,   418,   486,    46,
      66,    86,   116,   120,   121,   123,   124,   125,   128,   132,
     170,   175,   428,   487,   505,   486,   486,    51,    61,    66,
      80,   122,   123,   129,   136,   139,   141,   189,   191,   200,
     238,   256,   263,   264,   266,   271,   272,   274,   275,   277,
     280,   281,   294,   295,   299,   301,   302,   304,   309,   313,
     314,   316,   317,   319,   320,   321,   325,   428,   487,   486,
     486,    84,   346,   351,   352,   353,   385,   392,   428,   487,
     641,   642,   643,   486,   333,   401,   428,   487,   486,   486,
      66,   189,   313,   428,   487,   697,   700,    73,    74,    75,
      77,    78,    80,    84,    87,   428,   470,   473,   487,    75,
     155,   428,   472,   487,    36,    45,   427,   506,   466,     3,
       3,   466,    67,   467,    20,   448,   448,   558,   558,     3,
      36,    45,   427,   509,    86,   533,    19,    20,    45,   559,
       3,   188,   529,     3,     3,   526,   532,   270,    19,   123,
     196,   384,   398,   399,   522,   146,   196,   522,    18,    19,
     440,   442,   442,     3,     3,     3,     3,     3,     3,     3,
       3,    15,    19,    29,   424,   430,   593,   595,   601,    30,
     424,   254,    28,   254,    15,   430,   596,   603,   424,   424,
     424,   424,   424,   424,   230,   231,   232,   233,   582,   603,
      15,    16,    17,    19,   424,   577,   578,   581,   583,   584,
     585,   587,   589,   590,   591,     5,    82,    83,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   140,   179,   234,   235,
     237,   238,   239,   240,   241,   242,   243,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   311,   312,   326,   347,
     348,   349,   350,   416,   417,   602,   710,     3,     8,     9,
      10,    11,    12,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    33,    46,    47,    48,    49,    50,    51,    52,
      53,    54,   453,   454,    15,   548,   448,   638,    22,    63,
     450,    45,   427,   452,    15,    19,    35,    36,    37,    38,
      69,   424,   437,   439,   506,   437,    20,    58,    59,   423,
     437,   438,   438,   182,   171,   480,    15,    17,    18,    19,
     140,   424,   475,   561,    19,   477,   509,   423,   573,   140,
      19,   427,   427,   483,   427,   506,   323,    19,   491,   117,
     437,   439,   504,    45,    69,   126,   127,   137,   255,   488,
     569,    69,   488,   129,   446,    69,   446,   509,   423,   423,
     427,   427,   182,   283,   327,   323,    81,   423,    20,   286,
     287,   284,   446,   439,    69,    85,   189,   298,   324,   168,
      80,   439,   423,   437,   440,   628,   185,   440,    76,   273,
     282,    76,   271,   278,    87,   282,   296,   297,   296,   300,
     439,   303,   305,   310,    86,    87,   122,   315,    87,   318,
     316,   439,   266,   286,   439,   423,   427,   427,   383,   475,
     439,   116,   437,   439,   117,   423,   427,   427,    86,   402,
     403,   423,   427,   427,   323,   442,    86,   423,   207,   276,
     306,   315,   419,   420,   421,   422,   427,   703,    86,   439,
      76,   439,    79,    81,    85,   437,   423,   423,   423,    76,
     448,   423,   423,    79,   130,   131,   143,   144,   146,   507,
     508,     3,   467,     3,   437,     3,     3,     3,     3,     3,
     130,   176,   510,   511,     3,    19,     3,   559,     3,     3,
       3,    86,   158,   173,   185,   530,     3,    45,    86,   118,
     125,   126,   138,   155,   156,   157,   158,   160,   161,   442,
     527,   569,     3,    19,    86,   118,   119,   126,   163,   201,
     522,   522,   522,   679,    45,   522,    45,   522,     3,   522,
     522,     3,    30,   426,   444,   183,   183,     7,   595,   595,
     603,   595,   595,    14,    15,   603,   607,   608,    27,    28,
     254,    28,   596,   596,    30,   603,   603,   603,   603,   603,
      19,    15,   429,   425,   429,    29,   580,   582,   603,     7,
     429,   432,    27,    28,   427,   429,   432,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   211,   236,   244,   249,   250,   251,   428,   429,     3,
       3,     3,    86,   126,   142,   569,   603,   446,   453,   423,
     438,   603,   437,    60,    61,    60,    61,    39,    40,    41,
     437,   499,   500,   603,   423,   209,   210,   211,   212,   213,
     214,   215,   216,   218,   219,   220,   221,   222,   223,   563,
     564,   565,   567,   571,    42,   166,   167,   168,   423,   478,
     423,   424,   570,    19,   163,   428,   439,   475,   493,   496,
     497,    36,   437,   490,    19,   567,   568,   138,   603,   490,
     490,   612,    76,    76,    80,   328,   439,    76,   322,   439,
     423,   437,   437,    51,   329,   423,   423,   437,   259,   260,
     439,   308,   439,   176,   440,   423,   423,   423,    31,   441,
      42,   185,   423,   437,   185,   437,    76,    76,   437,    76,
     137,   279,   439,    76,   423,   117,   423,   439,   423,   439,
     279,   306,   307,   439,   491,   439,   423,   423,   439,   439,
     439,   423,   185,   439,   423,   635,   439,   439,    69,   437,
     644,    19,   423,   423,   684,   439,   491,    20,   440,   440,
     276,   698,   699,   702,   423,   437,   437,   439,   439,   439,
     437,   440,   442,   443,   428,   429,     3,   428,   429,     3,
      19,    15,   442,    19,    19,   568,   443,    19,     3,    20,
     447,   447,     3,    19,   116,   279,   323,   346,   361,   390,
     391,   522,   447,   522,   447,   447,   447,   437,   440,    15,
      15,    15,   425,   429,   425,   254,    28,   429,   429,   429,
     425,   429,   425,   429,   603,   603,   429,     7,   429,   429,
     425,    18,   424,   578,   585,    15,    18,   590,   424,   454,
      20,   491,   568,   446,   423,   428,   425,    20,   423,   497,
     423,   425,    19,   217,   423,   427,   437,   440,   425,   564,
     566,   571,   442,   423,    28,   495,   429,   133,   489,   439,
     123,   263,   264,   428,   487,   611,   437,   437,    81,    76,
     423,   437,   423,   423,   423,   423,   439,   427,   439,   629,
     423,   423,   423,   423,   439,   423,   439,   423,    19,   628,
     437,   437,   423,   437,   423,   437,   437,   423,   437,   423,
     423,   423,   437,   475,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   437,   423,    86,   126,
     342,   343,   344,   428,   487,   569,   634,   437,   123,   129,
     188,   352,   374,   376,   381,   383,   387,   388,   428,   645,
     652,   655,   423,   123,   385,   405,   428,   487,   683,   423,
     423,   441,   440,   256,   386,   698,    19,    51,   120,   202,
     203,   204,   205,   206,   207,   208,   224,   227,   256,   428,
     599,   600,   604,   609,   701,    69,   469,   508,   511,     3,
       3,   475,   475,    15,   475,   447,     3,   447,     3,     3,
       3,   185,   185,   595,   607,    28,    28,   603,   603,   603,
     603,   603,   429,   425,   429,    29,   580,   603,   580,    29,
     580,   580,   603,   429,   603,   565,   574,   575,   609,   423,
     425,   183,    20,   443,   494,   496,    81,   134,   135,   136,
     614,   620,   614,   621,   440,   625,   423,   429,   423,   322,
     439,   437,   423,   423,   174,   212,   329,   331,   333,   334,
     337,   630,   631,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,    20,   568,   446,   437,   191,   423,
     664,   670,   354,   355,   387,   439,   354,   439,   646,   323,
     442,   648,   649,   647,   389,   439,   423,   392,   665,   686,
     692,   439,   437,   423,   441,   439,   437,    22,   424,    22,
     424,   603,   603,   603,   439,   602,   710,   423,   603,   605,
     606,   437,     3,     3,    15,    15,    28,   425,   425,   425,
     425,   429,   603,   603,   425,   429,     7,   425,   429,   425,
     429,     7,   425,   429,   429,    15,   425,   428,   609,   566,
      15,   443,   497,   498,   427,   619,    31,   265,   622,   437,
     423,   423,   423,   340,    69,   247,   332,   336,   335,   338,
     339,   428,   429,   280,   497,   666,   437,   437,   439,   437,
     427,   475,   427,   427,   437,   437,   427,   498,    69,   603,
     608,   603,   599,   423,   225,   427,   423,    22,    22,    33,
     429,   423,   533,   533,    28,   603,   425,   425,    29,   580,
      29,   580,    29,   580,     7,    29,   580,    29,   580,   428,
     185,   619,   618,   615,    19,   446,   266,   623,   423,   194,
     330,   631,   439,   667,   427,   669,   657,   650,   657,   653,
     427,   691,   437,   423,   425,   423,   710,   427,   576,   609,
     592,   603,   603,   126,   191,   192,   248,   254,   606,     3,
       3,   425,   425,   425,   425,   429,     7,   425,   425,   425,
     429,   424,   425,     7,   425,   425,     7,   425,    15,   615,
     139,   141,   169,   257,   258,   261,   262,   267,   428,   512,
     514,   515,   616,   440,   263,   624,   665,   668,   428,   442,
     658,   659,   188,   354,   375,   428,   651,   428,   182,   267,
     356,   357,   358,   360,   428,   512,   654,   690,   687,   425,
     574,   226,     6,    15,    16,    17,   424,   428,   577,   579,
     581,   583,   584,   586,   588,   423,   423,   424,   424,   424,
     424,   423,    29,   580,    29,   580,   580,     7,   580,   423,
     446,   439,   427,   259,   260,   260,   438,   437,   127,   148,
     268,   269,   617,   427,   423,   439,    66,   182,   196,   256,
     259,   260,   267,   317,   320,   323,   352,   354,   356,   357,
     358,   359,   360,   361,   367,   370,   373,   385,   393,   428,
     512,   656,   375,   382,   660,   439,   437,   439,   423,   437,
     127,   268,   371,   437,   437,   282,   157,   437,   423,    42,
      66,    67,    87,   141,   168,   256,   259,   260,   267,   317,
     385,   401,   406,   407,   409,   410,   412,   428,   512,   688,
     423,   428,   576,   574,   603,     7,   426,   429,   603,   603,
     603,   603,   425,   425,   425,   429,   425,   424,   425,   513,
     514,   261,   261,   261,   150,   151,   148,   117,   140,   142,
     147,   162,   206,   516,   323,   437,   427,   439,   378,   180,
     181,   359,   395,   501,   127,   268,   371,   318,   439,   396,
     439,   437,   437,   437,   282,   437,   157,   437,   362,   363,
     364,   365,   366,   367,   368,   369,   394,   364,   437,   386,
     362,   423,   437,   423,   437,   437,   437,   323,   414,    76,
     437,   439,   440,   439,   378,   359,   395,   501,   127,   150,
     371,   415,   689,   318,   386,   362,   408,    76,    76,   377,
     437,   411,   413,   423,   425,   424,   579,   574,   586,   425,
     425,   425,   425,   580,   580,   428,   423,   438,   438,   438,
     150,   151,   437,    20,   445,   445,   148,   149,   517,   140,
     142,   140,   142,   428,   439,   661,   379,   380,   437,   437,
     437,   437,   437,   260,   439,   397,   437,   437,   439,   439,
     437,   439,   439,   439,   437,   437,   437,   437,   260,   439,
     437,   437,   437,   439,   439,   439,   603,   423,   423,   423,
     423,   425,   429,   513,   423,   423,   423,   150,   151,   152,
     153,   154,   150,   151,   152,   153,   154,   423,   445,   445,
     445,   445,   428,   440,   663,   377,   439,   377,   580,   516,
     516,   516,   516,   423,   423,   423,   423,   372,   662,   429,
     516,   516,   516,   516,   423,   580,   425
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   433,   434,   434,   435,   435,   436,   437,   437,   437,
     438,   438,   438,   439,   439,   439,   439,   439,   439,   440,
     440,   441,   441,   442,   443,   443,   444,   444,   445,   446,
     446,   447,   447,   448,   448,   449,   450,   450,   451,   451,
     451,   452,   452,   453,   453,   454,   454,   454,   454,   454,
     454,   454,   454,   454,   455,   455,   456,   456,   456,   456,
     457,   457,   457,   457,   457,   457,   458,   459,   459,   459,
     459,   460,   461,   462,   463,   464,   465,   466,   466,   467,
     467,   467,   468,   469,   469,   470,   470,   470,   470,   470,
     470,   471,   472,   472,   473,   473,   474,   474,   475,   475,
     475,   475,   475,   476,   477,   477,   478,   478,   478,   478,
     479,   480,   480,   481,   482,   483,   483,   484,   484,   485,
     485,   486,   486,   486,   486,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   488,   488,   488,   488,   489,   489,   489,   489,   489,
     490,   490,   491,   492,   492,   493,   494,   494,   494,   495,
     495,   496,   497,   497,   498,   499,   500,   501,   501,   502,
     503,   503,   503,   503,   504,   505,   506,   506,   506,   507,
     507,   508,   508,   508,   508,   508,   508,   509,   509,   509,
     510,   510,   511,   511,   512,   512,   513,   513,   514,   514,
     515,   516,   516,   516,   516,   516,   516,   516,   516,   516,
     517,   517,   517,   517,   517,   517,   517,   517,   517,   517,
     518,   519,   520,   521,   522,   522,   523,   524,   525,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   526,   527,   527,   527,   528,   529,   529,   529,   529,
     530,   530,   530,   531,   532,   532,   532,   532,   532,   532,
     532,   532,   533,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   547,   547,
     548,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   558,   558,   559,   559,   559,   561,   560,   562,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   564,   565,   565,   566,   566,
     567,   568,   568,   569,   570,   570,   571,   573,   572,   574,
     574,   575,   575,   576,   576,   577,   578,   578,   578,   578,
     578,   578,   579,   579,   579,   579,   579,   580,   581,   581,
     581,   581,   581,   581,   581,   581,   581,   581,   582,   582,
     582,   582,   583,   583,   583,   584,   584,   584,   584,   584,
     584,   584,   584,   585,   585,   585,   585,   585,   586,   586,
     586,   586,   586,   587,   587,   588,   588,   589,   590,   590,
     590,   590,   591,   591,   592,   592,   592,   593,   593,   594,
     594,   595,   595,   595,   595,   595,   595,   596,   596,   596,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     598,   598,   598,   598,   599,   600,   601,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   604,   604,   604,
     604,   604,   604,   605,   606,   606,   606,   607,   607,   608,
     608,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   609,   609,   610,   611,   611,
     611,   611,   612,   612,   613,   614,   615,   616,   616,   616,
     616,   616,   616,   616,   616,   617,   617,   617,   617,   617,
     617,   618,   618,   619,   619,   620,   621,   622,   622,   622,
     623,   623,   624,   624,   625,   626,   627,   628,   628,   628,
     629,   629,   630,   630,   631,   631,   631,   631,   631,   631,
     631,   631,   631,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   633,
     634,   634,   634,   634,   634,   634,   634,   635,   635,   636,
     637,   638,   638,   638,   638,   638,   638,   639,   640,   640,
     641,   641,   641,   641,   641,   641,   641,   641,   641,   642,
     643,   644,   644,   645,   645,   645,   645,   645,   645,   645,
     645,   645,   646,   645,   647,   645,   645,   645,   645,   648,
     648,   649,   650,   650,   651,   651,   651,   652,   652,   653,
     653,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   655,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   657,   657,   658,   659,   660,   660,   660,   661,
     661,   662,   662,   663,   664,   665,   665,   667,   666,   668,
     668,   669,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   679,   679,   679,   679,   679,   679,   679,
     679,   680,   681,   681,   681,   681,   681,   682,   683,   683,
     683,   683,   683,   684,   684,   685,   686,   687,   688,   688,
     688,   688,   688,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   688,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   688,   689,   689,   689,   689,   690,   690,   691,
     691,   692,   693,   694,   695,   696,   696,   696,   696,   696,
     697,   698,   698,   698,   699,   699,   700,   700,   700,   700,
     700,   700,   700,   700,   700,   701,   701,   702,   702,   703,
     703,   704,   705,   705,   705,   705,   705,   705,   705,   705,
     705,   705,   705,   705,   705,   705,   705,   705,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   707,   707,
     707,   707,   707,   707,   707,   707,   707,   707,   708,   708,
     708,   708,   709,   709,   709,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     4,     5,     3,     3,     4,     2,     0,     1,     0,
       1,     2,     2,     0,     2,     2,     3,     2,     3,     3,
       4,     2,     3,     3,     3,     2,     4,     5,     1,     3,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     2,     3,     0,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     4,     2,     2,     2,     3,
       2,     2,     1,     1,     1,     0,     2,     2,     2,     2,
       2,     1,     1,     3,     3,     0,     1,     1,     2,     0,
       1,     3,     1,     3,     1,     0,     2,     2,     2,     2,
       3,     3,     3,     5,     0,     3,     1,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     3,     1,     1,     4,     1,     0,     3,     4,     1,
       2,     0,     5,     5,     5,     5,     4,     4,     4,     4,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     3,     4,     5,     1,     0,     3,     4,     4,     0,
       2,     3,     3,     3,     2,     2,     2,     2,     3,     3,
       2,     2,     1,     1,     1,     4,     0,     3,     3,     3,
       0,     1,     1,     4,     0,     2,     2,     2,     2,     2,
       2,     2,     0,     2,     9,     9,     4,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     1,     1,     3,
       0,     1,     4,     4,     4,     3,     4,     4,     4,     4,
       2,     1,     1,     1,     1,     0,     1,     0,     4,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     0,     3,     1,     3,
       1,     1,     1,     2,     3,     2,     4,     0,     5,     0,
       1,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       3,     1,     1,     3,     1,     1,     1,     1,     5,     7,
       5,     7,     9,     7,     5,     7,     5,    11,     1,     1,
       2,     1,     7,     9,     7,     7,     9,     7,     9,     7,
       9,     7,    15,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     3,     1,     3,     1,     3,     3,     1,     2,
       2,     6,     1,     3,     0,     4,     3,     1,     3,     3,
       3,     2,     4,     2,     2,     2,     0,     2,     2,     0,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
       5,     7,     7,     1,     0,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     4,     1,     1,     1,     1,     2,     2,
       3,     3,     6,     3,     3,     3,     3,     3,     5,     7,
       6,     6,     6,     6,     4,     8,     4,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     3,     1,     3,     0,
       1,     4,     6,     4,     3,     5,     5,     4,     6,     3,
       2,     5,     5,     8,     8,     8,     8,     2,     1,     2,
       2,     2,     0,     3,     5,     0,     0,     2,     4,     4,
       4,     2,     2,     2,     1,     1,     1,     2,     2,     3,
       3,     0,     3,     0,     3,     4,     3,     0,     2,     2,
       0,     2,     0,     2,     4,     5,     2,     0,     3,     3,
       1,     3,     1,     3,     1,     3,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     5,     6,     4,     6,     4,
       6,     4,     4,     5,     6,     3,     3,     4,     5,     5,
       5,     5,     5,     4,     4,     5,     5,     5,     5,     5,
       5,     5,     5,     6,     6,     6,     5,     6,     8,     6,
       6,     6,     5,     6,     4,     5,     4,     4,     5,     4,
       5,     4,     5,     5,     5,     5,     5,     6,     5,     5,
       6,     7,     7,     7,     5,     5,     5,     4,     4,     2,
       1,     2,     2,     1,     2,     2,     4,     0,     3,     5,
       4,     0,     3,     3,     3,     2,     3,     2,     3,     3,
       1,     2,     3,     2,     4,     3,     2,     3,     1,     2,
       4,     0,     3,     2,     1,     2,     3,     3,     3,     3,
       2,     3,     0,     5,     0,     5,     2,     2,     1,     4,
       1,     1,     0,     3,     2,     2,     2,     5,     2,     0,
       3,     0,     2,     2,     3,     2,     2,     3,     2,     2,
       2,     1,     3,     2,     2,     2,     2,     2,     2,     3,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     2,     3,     2,     3,     3,     4,     4,     2,     2,
       2,     3,     3,     3,     2,     3,     3,     3,     4,     2,
       2,     1,     0,     2,     3,     1,     0,     1,     2,     0,
       2,     0,     1,     3,     0,     0,     2,     0,     3,     0,
       3,     0,     3,     3,     4,     6,     6,     6,     7,     6,
       7,     5,     0,     2,     3,     2,     3,     3,     2,     3,
       2,     2,     3,     3,     5,     4,     4,     2,     1,     2,
       4,     2,     2,     0,     3,     5,     0,     0,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     4,     3,
       2,     2,     1,     1,     1,     1,     1,     0,     3,     0,
       3,     4,     6,     6,     2,     3,     3,     5,     5,     4,
       2,     3,     3,     3,     1,     2,     4,     3,     3,     3,
       2,     2,     2,     2,     2,     1,     3,     0,     2,     0,
       3,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     1,     2,     1,     2,     2,     1,     2,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 841 "cf-parse.y" /* yacc.c:1648  */
    { return 0; }
#line 4123 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 3:
#line 842 "cf-parse.y" /* yacc.c:1648  */
    { return 0; }
#line 4129 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 6:
#line 855 "cf-parse.y" /* yacc.c:1648  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 4140 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 8:
#line 865 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 4146 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 9:
#line 866 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 4154 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 10:
#line 873 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 4160 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 11:
#line 874 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 4166 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 12:
#line 875 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 4172 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 13:
#line 883 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = !!(yyvsp[0].i); }
#line 4178 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 14:
#line 884 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1; }
#line 4184 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 15:
#line 885 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1; }
#line 4190 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 16:
#line 886 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 4196 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 17:
#line 887 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 4202 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 18:
#line 888 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1; }
#line 4208 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 20:
#line 895 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 4217 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 21:
#line 902 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.iface) = NULL; }
#line 4223 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 22:
#line 903 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 4229 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 23:
#line 907 "cf-parse.y" /* yacc.c:1648  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 4238 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 25:
#line 915 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 4244 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 26:
#line 919 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 4253 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 27:
#line 923 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 4262 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 28:
#line 930 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 4272 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 30:
#line 939 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 4281 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 32:
#line 947 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = NULL; }
#line 4287 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 33:
#line 951 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4293 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 34:
#line 952 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = NULL; }
#line 4299 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 35:
#line 958 "cf-parse.y" /* yacc.c:1648  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 4310 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 36:
#line 967 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4316 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 37:
#line 968 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = bird_name; }
#line 4322 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 38:
#line 972 "cf-parse.y" /* yacc.c:1648  */
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = rf_file(f);
   }
#line 4332 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 39:
#line 977 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 4338 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 40:
#line 978 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.g) = stderr; }
#line 4344 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 41:
#line 982 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ~0; }
#line 4350 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 42:
#line 983 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4356 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 43:
#line 987 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 4362 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 44:
#line 988 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 4368 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 45:
#line 992 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_DEBUG[0]; }
#line 4374 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 46:
#line 993 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_TRACE[0]; }
#line 4380 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 47:
#line 994 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_INFO[0]; }
#line 4386 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 48:
#line 995 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_REMOTE[0]; }
#line 4392 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 49:
#line 996 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_WARN[0]; }
#line 4398 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 50:
#line 997 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_ERR[0]; }
#line 4404 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 51:
#line 998 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_AUTH[0]; }
#line 4410 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 52:
#line 999 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_FATAL[0]; }
#line 4416 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 53:
#line 1000 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_BUG[0]; }
#line 4422 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 54:
#line 1006 "cf-parse.y" /* yacc.c:1648  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4428 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 55:
#line 1007 "cf-parse.y" /* yacc.c:1648  */
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = rf_fileno(f);
   }
#line 4438 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 56:
#line 1017 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4444 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 57:
#line 1018 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4450 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 58:
#line 1019 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4456 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 59:
#line 1020 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4462 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 60:
#line 1023 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4468 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 61:
#line 1024 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4474 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 62:
#line 1025 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4480 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 63:
#line 1026 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4486 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 64:
#line 1027 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4492 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 65:
#line 1028 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4498 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 67:
#line 1038 "cf-parse.y" /* yacc.c:1648  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4504 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 68:
#line 1039 "cf-parse.y" /* yacc.c:1648  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4510 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 69:
#line 1040 "cf-parse.y" /* yacc.c:1648  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4516 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 70:
#line 1041 "cf-parse.y" /* yacc.c:1648  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4522 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 71:
#line 1050 "cf-parse.y" /* yacc.c:1648  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4528 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 72:
#line 1053 "cf-parse.y" /* yacc.c:1648  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4534 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 73:
#line 1060 "cf-parse.y" /* yacc.c:1648  */
    { cmd_reconfig_confirm(); }
#line 4540 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 74:
#line 1063 "cf-parse.y" /* yacc.c:1648  */
    { cmd_reconfig_undo(); }
#line 4546 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 75:
#line 1066 "cf-parse.y" /* yacc.c:1648  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4552 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 76:
#line 1069 "cf-parse.y" /* yacc.c:1648  */
    { cmd_shutdown(); }
#line 4558 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 77:
#line 1072 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = NULL; }
#line 4564 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 79:
#line 1077 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 4570 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 80:
#line 1078 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4576 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 81:
#line 1079 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4582 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 82:
#line 1087 "cf-parse.y" /* yacc.c:1648  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4588 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 83:
#line 1092 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 4594 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 84:
#line 1093 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 4600 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 85:
#line 1097 "cf-parse.y" /* yacc.c:1648  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4606 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 86:
#line 1098 "cf-parse.y" /* yacc.c:1648  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4615 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 87:
#line 1102 "cf-parse.y" /* yacc.c:1648  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 4627 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 88:
#line 1109 "cf-parse.y" /* yacc.c:1648  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4633 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 89:
#line 1110 "cf-parse.y" /* yacc.c:1648  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4639 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 90:
#line 1111 "cf-parse.y" /* yacc.c:1648  */
    {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 4651 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 91:
#line 1123 "cf-parse.y" /* yacc.c:1648  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4657 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 92:
#line 1128 "cf-parse.y" /* yacc.c:1648  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4666 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 93:
#line 1132 "cf-parse.y" /* yacc.c:1648  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4678 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 94:
#line 1146 "cf-parse.y" /* yacc.c:1648  */
    { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 4684 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 95:
#line 1147 "cf-parse.y" /* yacc.c:1648  */
    { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 4690 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 96:
#line 1161 "cf-parse.y" /* yacc.c:1648  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4696 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 97:
#line 1162 "cf-parse.y" /* yacc.c:1648  */
    { new_config->router_id_from = this_ipatt; }
#line 4702 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 98:
#line 1166 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4708 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 99:
#line 1167 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = f_eval_int((yyvsp[-1].x)); }
#line 4714 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 101:
#line 1169 "cf-parse.y" /* yacc.c:1648  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4726 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 102:
#line 1176 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
#ifndef IPV6
     else if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 4741 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 106:
#line 1198 "cf-parse.y" /* yacc.c:1648  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4747 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 107:
#line 1199 "cf-parse.y" /* yacc.c:1648  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4753 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 108:
#line 1200 "cf-parse.y" /* yacc.c:1648  */
    { new_config->listen_bgp_flags = 0; }
#line 4759 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 109:
#line 1201 "cf-parse.y" /* yacc.c:1648  */
    { new_config->listen_bgp_flags = 1; }
#line 4765 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 110:
#line 1206 "cf-parse.y" /* yacc.c:1648  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4771 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 111:
#line 1212 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 4777 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 112:
#line 1213 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1; }
#line 4783 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 113:
#line 1217 "cf-parse.y" /* yacc.c:1648  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4793 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 114:
#line 1225 "cf-parse.y" /* yacc.c:1648  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4801 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 116:
#line 1231 "cf-parse.y" /* yacc.c:1648  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4809 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 119:
#line 1245 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = SYM_PROTO; }
#line 4815 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 120:
#line 1246 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4821 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 121:
#line 1250 "cf-parse.y" /* yacc.c:1648  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4832 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 122:
#line 1256 "cf-parse.y" /* yacc.c:1648  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4841 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 123:
#line 1260 "cf-parse.y" /* yacc.c:1648  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4855 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 124:
#line 1269 "cf-parse.y" /* yacc.c:1648  */
    {
     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4867 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 126:
#line 1280 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4876 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 127:
#line 1284 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4882 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 128:
#line 1285 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4888 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 129:
#line 1286 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4894 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 130:
#line 1287 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4900 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 131:
#line 1288 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4906 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 132:
#line 1289 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4912 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 133:
#line 1290 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4918 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 134:
#line 1291 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4924 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 135:
#line 1292 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4930 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 136:
#line 1293 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->vrf = if_get_by_name((yyvsp[0].t)); this_proto->vrf_set = 1; }
#line 4936 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 137:
#line 1294 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->vrf = NULL; this_proto->vrf_set = 1; }
#line 4942 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 138:
#line 1295 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->table = (yyvsp[0].r); }
#line 4948 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 139:
#line 1296 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4954 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 140:
#line 1297 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4960 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 141:
#line 1301 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4966 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 143:
#line 1303 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4972 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 144:
#line 1304 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.f) = FILTER_REJECT; }
#line 4978 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 145:
#line 1308 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = PLA_DISABLE; }
#line 4984 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 146:
#line 1309 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = PLA_WARN; }
#line 4990 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 147:
#line 1310 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = PLA_BLOCK; }
#line 4996 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 148:
#line 1311 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = PLA_RESTART; }
#line 5002 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 149:
#line 1312 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = PLA_DISABLE; }
#line 5008 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 150:
#line 1316 "cf-parse.y" /* yacc.c:1648  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 5019 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 151:
#line 1322 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.g) = NULL; }
#line 5025 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 152:
#line 1326 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 5034 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 153:
#line 1334 "cf-parse.y" /* yacc.c:1648  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 5040 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 154:
#line 1335 "cf-parse.y" /* yacc.c:1648  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 5046 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 155:
#line 1343 "cf-parse.y" /* yacc.c:1648  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 5056 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 156:
#line 1351 "cf-parse.y" /* yacc.c:1648  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 5062 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 157:
#line 1352 "cf-parse.y" /* yacc.c:1648  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5068 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 158:
#line 1353 "cf-parse.y" /* yacc.c:1648  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5074 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 159:
#line 1357 "cf-parse.y" /* yacc.c:1648  */
    { this_ipn->positive = 1; }
#line 5080 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 160:
#line 1358 "cf-parse.y" /* yacc.c:1648  */
    { this_ipn->positive = 0; }
#line 5086 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 164:
#line 1372 "cf-parse.y" /* yacc.c:1648  */
    { iface_patt_check(); }
#line 5092 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 165:
#line 1374 "cf-parse.y" /* yacc.c:1648  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 5102 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 167:
#line 1386 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 5108 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 168:
#line 1387 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 5114 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 169:
#line 1393 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 5123 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 173:
#line 1403 "cf-parse.y" /* yacc.c:1648  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 5129 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 174:
#line 1407 "cf-parse.y" /* yacc.c:1648  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 5139 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 176:
#line 1421 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ~0; }
#line 5145 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 177:
#line 1422 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 5151 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 178:
#line 1423 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5157 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 180:
#line 1428 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5163 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 181:
#line 1432 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_STATES; }
#line 5169 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 182:
#line 1433 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_ROUTES; }
#line 5175 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 183:
#line 1434 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_FILTERS; }
#line 5181 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 184:
#line 1435 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_IFACES; }
#line 5187 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 185:
#line 1436 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_EVENTS; }
#line 5193 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 186:
#line 1437 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_PACKETS; }
#line 5199 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 187:
#line 1443 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ~0; }
#line 5205 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 188:
#line 1444 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 5211 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 189:
#line 1445 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5217 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 191:
#line 1450 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5223 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 192:
#line 1454 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = MD_STATES; }
#line 5229 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 193:
#line 1455 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = MD_MESSAGES; }
#line 5235 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 200:
#line 1476 "cf-parse.y" /* yacc.c:1648  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->length = strlen((yyvsp[0].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 5257 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 201:
#line 1496 "cf-parse.y" /* yacc.c:1648  */
    { }
#line 5263 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 202:
#line 1497 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 5269 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 203:
#line 1498 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 5275 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 204:
#line 1499 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 5281 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 205:
#line 1500 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 5287 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 206:
#line 1501 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 5293 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 207:
#line 1502 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 5299 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 208:
#line 1503 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 5305 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 209:
#line 1504 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->alg = (yyvsp[-2].i); }
#line 5311 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 210:
#line 1508 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_MD5; }
#line 5317 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 211:
#line 1509 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_SHA1; }
#line 5323 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 212:
#line 1510 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_SHA256; }
#line 5329 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 213:
#line 1511 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_SHA384; }
#line 5335 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 214:
#line 1512 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_SHA512; }
#line 5341 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 215:
#line 1513 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_HMAC_MD5; }
#line 5347 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 216:
#line 1514 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_HMAC_SHA1; }
#line 5353 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 217:
#line 1515 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_HMAC_SHA256; }
#line 5359 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 218:
#line 1516 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_HMAC_SHA384; }
#line 5365 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 219:
#line 1517 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_HMAC_SHA512; }
#line 5371 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 220:
#line 1524 "cf-parse.y" /* yacc.c:1648  */
    { cmd_show_status(); }
#line 5377 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 221:
#line 1527 "cf-parse.y" /* yacc.c:1648  */
    { cmd_show_memory(); }
#line 5383 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 222:
#line 1530 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 5389 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 223:
#line 1533 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 5395 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 225:
#line 1537 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.s) = NULL; }
#line 5401 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 226:
#line 1541 "cf-parse.y" /* yacc.c:1648  */
    { if_show(); }
#line 5407 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 227:
#line 1544 "cf-parse.y" /* yacc.c:1648  */
    { if_show_summary(); }
#line 5413 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 228:
#line 1548 "cf-parse.y" /* yacc.c:1648  */
    { rt_show((yyvsp[-1].ra)); }
#line 5419 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 229:
#line 1551 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 5429 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 230:
#line 1556 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 5440 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 231:
#line 1562 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 5452 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 232:
#line 1569 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 5462 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 233:
#line 1574 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5472 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 234:
#line 1579 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5482 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 235:
#line 1584 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 5491 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 236:
#line 1588 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 5500 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 237:
#line 1592 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 5509 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 238:
#line 1596 "cf-parse.y" /* yacc.c:1648  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5523 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 239:
#line 1605 "cf-parse.y" /* yacc.c:1648  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5536 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 240:
#line 1613 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 5545 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 241:
#line 1617 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 5554 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 242:
#line 1624 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 5560 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 243:
#line 1625 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RSEM_EXPORT; }
#line 5566 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 244:
#line 1626 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 5572 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 245:
#line 1632 "cf-parse.y" /* yacc.c:1648  */
    { roa_show((yyvsp[-1].ro)); }
#line 5578 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 246:
#line 1635 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5590 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 247:
#line 1642 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5602 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 248:
#line 1649 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5611 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 249:
#line 1653 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5621 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 250:
#line 1661 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5627 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 251:
#line 1662 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5633 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 252:
#line 1663 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5639 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 253:
#line 1669 "cf-parse.y" /* yacc.c:1648  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5645 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 254:
#line 1672 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5653 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 255:
#line 1675 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5659 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 256:
#line 1676 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5665 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 257:
#line 1677 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5671 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 258:
#line 1678 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5677 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 259:
#line 1679 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5683 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 260:
#line 1680 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5689 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 261:
#line 1681 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5695 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 262:
#line 1686 "cf-parse.y" /* yacc.c:1648  */
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5705 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 263:
#line 1691 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5715 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 264:
#line 1700 "cf-parse.y" /* yacc.c:1648  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5724 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 265:
#line 1707 "cf-parse.y" /* yacc.c:1648  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5733 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 266:
#line 1714 "cf-parse.y" /* yacc.c:1648  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5742 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 267:
#line 1722 "cf-parse.y" /* yacc.c:1648  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5748 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 268:
#line 1724 "cf-parse.y" /* yacc.c:1648  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5754 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 269:
#line 1726 "cf-parse.y" /* yacc.c:1648  */
    { io_log_dump(); cli_msg(0, ""); }
#line 5760 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 270:
#line 1728 "cf-parse.y" /* yacc.c:1648  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5766 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 271:
#line 1730 "cf-parse.y" /* yacc.c:1648  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5772 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 272:
#line 1732 "cf-parse.y" /* yacc.c:1648  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5778 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 273:
#line 1734 "cf-parse.y" /* yacc.c:1648  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5784 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 274:
#line 1736 "cf-parse.y" /* yacc.c:1648  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5790 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 275:
#line 1739 "cf-parse.y" /* yacc.c:1648  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5796 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 276:
#line 1742 "cf-parse.y" /* yacc.c:1648  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5805 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 277:
#line 1748 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ~0; }
#line 5811 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 278:
#line 1749 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 5817 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 279:
#line 1750 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5823 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 280:
#line 1754 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 4096; }
#line 5829 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 281:
#line 1755 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5838 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 282:
#line 1762 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 5844 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 283:
#line 1764 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 5850 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 284:
#line 1766 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 5856 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 285:
#line 1768 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5862 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 286:
#line 1770 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5868 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 287:
#line 1772 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5874 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 288:
#line 1776 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5880 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 289:
#line 1780 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5886 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 290:
#line 1783 "cf-parse.y" /* yacc.c:1648  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5892 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 291:
#line 1786 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5898 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 292:
#line 1787 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5904 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 293:
#line 1788 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5910 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 294:
#line 1792 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5916 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 295:
#line 1793 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5922 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 296:
#line 1794 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5928 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 297:
#line 1802 "cf-parse.y" /* yacc.c:1648  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5934 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 298:
#line 1803 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5945 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 299:
#line 1812 "cf-parse.y" /* yacc.c:1648  */
    { f_eval_int((yyvsp[0].x)); }
#line 5951 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 300:
#line 1816 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_INT; }
#line 5957 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 301:
#line 1817 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_BOOL; }
#line 5963 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 302:
#line 1818 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_IP; }
#line 5969 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 303:
#line 1819 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_PREFIX; }
#line 5975 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 304:
#line 1820 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_PAIR; }
#line 5981 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 305:
#line 1821 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_QUAD; }
#line 5987 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 306:
#line 1822 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_EC; }
#line 5993 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 307:
#line 1823 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_LC; }
#line 5999 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 308:
#line 1824 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_STRING; }
#line 6005 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 309:
#line 1825 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_PATH_MASK; }
#line 6011 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 310:
#line 1826 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_PATH; }
#line 6017 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 311:
#line 1827 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_CLIST; }
#line 6023 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 312:
#line 1828 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_ECLIST; }
#line 6029 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 313:
#line 1829 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_LCLIST; }
#line 6035 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 314:
#line 1830 "cf-parse.y" /* yacc.c:1648  */
    {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 6059 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 315:
#line 1852 "cf-parse.y" /* yacc.c:1648  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 6072 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 316:
#line 1863 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.s) = NULL; }
#line 6078 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 317:
#line 1864 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6087 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 318:
#line 1871 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.s) = (yyvsp[0].s); }
#line 6093 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 319:
#line 1872 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6102 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 320:
#line 1879 "cf-parse.y" /* yacc.c:1648  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 6113 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 321:
#line 1888 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 6122 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 323:
#line 1896 "cf-parse.y" /* yacc.c:1648  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst(FI_PRINT_AND_DIE);	/* ACCEPT */
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst(FI_PRINT_AND_DIE);	/* REJECT */
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst(FI_CONDITION);			/* IF */
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 6145 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 324:
#line 1917 "cf-parse.y" /* yacc.c:1648  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 6151 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 325:
#line 1918 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.s)=NULL; }
#line 6157 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 326:
#line 1922 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst(FI_CLEAR_LOCAL_VARS);
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 6171 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 327:
#line 1934 "cf-parse.y" /* yacc.c:1648  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 6180 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 328:
#line 1937 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name);
     cf_pop_scope();
   }
#line 6191 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 329:
#line 1950 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = NULL; }
#line 6197 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 330:
#line 1951 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 6203 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 331:
#line 1954 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 6209 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 332:
#line 1955 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 6215 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 333:
#line 1959 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 6223 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 334:
#line 1962 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 6231 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 335:
#line 1971 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 6237 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 336:
#line 1984 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6243 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 337:
#line 1985 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6249 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 338:
#line 1986 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6255 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 339:
#line 1987 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6261 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 340:
#line 1988 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 6270 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 341:
#line 1992 "cf-parse.y" /* yacc.c:1648  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 6280 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 342:
#line 2000 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6286 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 343:
#line 2001 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 6292 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 344:
#line 2002 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6298 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 345:
#line 2003 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6304 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 346:
#line 2004 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6310 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 347:
#line 2008 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 6316 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 348:
#line 2011 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6322 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 349:
#line 2012 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6328 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 350:
#line 2013 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6334 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 351:
#line 2014 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6340 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 352:
#line 2015 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6346 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 353:
#line 2016 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6352 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 354:
#line 2017 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6358 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 355:
#line 2018 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6364 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 356:
#line 2019 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 6370 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 357:
#line 2021 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 6376 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 358:
#line 2025 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = EC_RT; }
#line 6382 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 359:
#line 2026 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = EC_RO; }
#line 6388 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 360:
#line 2027 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6394 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 361:
#line 2028 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = EC_GENERIC; }
#line 6400 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 362:
#line 2032 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6406 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 363:
#line 2033 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6412 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 364:
#line 2034 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 6418 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 365:
#line 2038 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6424 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 366:
#line 2039 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6430 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 367:
#line 2040 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6436 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 368:
#line 2041 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6442 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 369:
#line 2042 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6448 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 370:
#line 2043 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6454 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 371:
#line 2044 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 6460 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 372:
#line 2046 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 6466 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 376:
#line 2053 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6472 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 377:
#line 2054 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6478 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 381:
#line 2061 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6484 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 382:
#line 2062 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6490 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 384:
#line 2067 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6496 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 386:
#line 2072 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6502 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 387:
#line 2076 "cf-parse.y" /* yacc.c:1648  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 6511 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 388:
#line 2083 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6517 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 389:
#line 2084 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 6523 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 390:
#line 2085 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 6529 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 391:
#line 2086 "cf-parse.y" /* yacc.c:1648  */
    {
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 6538 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 392:
#line 2093 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6544 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 393:
#line 2094 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6550 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 394:
#line 2097 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = NULL; }
#line 6556 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 395:
#line 2098 "cf-parse.y" /* yacc.c:1648  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6568 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 396:
#line 2105 "cf-parse.y" /* yacc.c:1648  */
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6580 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 397:
#line 2117 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6586 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 398:
#line 2118 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6592 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 399:
#line 2122 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6598 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 400:
#line 2123 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6604 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 401:
#line 2127 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6610 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 402:
#line 2128 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[-3].i); (yyval.h)->val2 = (yyvsp[-1].i); }
#line 6616 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 403:
#line 2129 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6622 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 404:
#line 2130 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; }
#line 6628 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 405:
#line 2131 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6634 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 406:
#line 2132 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = NULL; }
#line 6640 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 407:
#line 2136 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6646 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 408:
#line 2137 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6652 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 409:
#line 2138 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = NULL; }
#line 6658 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 410:
#line 2142 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6664 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 411:
#line 2143 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6670 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 412:
#line 2144 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6676 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 413:
#line 2145 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6682 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 414:
#line 2146 "cf-parse.y" /* yacc.c:1648  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6688 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 415:
#line 2147 "cf-parse.y" /* yacc.c:1648  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6694 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 416:
#line 2148 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6700 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 417:
#line 2149 "cf-parse.y" /* yacc.c:1648  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6706 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 418:
#line 2150 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6712 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 419:
#line 2151 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6718 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 420:
#line 2155 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6724 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 421:
#line 2156 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6730 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 422:
#line 2157 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_lc((yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6736 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 423:
#line 2158 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_path_mask((yyvsp[0].h)); }
#line 6742 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 425:
#line 2172 "cf-parse.y" /* yacc.c:1648  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6766 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 426:
#line 2194 "cf-parse.y" /* yacc.c:1648  */
    {
     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); break;
       case SYM_VARIABLE: (yyval.x) = f_new_inst(FI_VARIABLE); break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6781 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 427:
#line 2206 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	1); }
#line 6787 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 428:
#line 2207 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	1); }
#line 6793 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 429:
#line 2208 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_PREFIX,     SA_NET,	0); }
#line 6799 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 430:
#line 2209 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	0); }
#line 6805 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 431:
#line 2210 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	0); }
#line 6811 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 432:
#line 2211 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	1); }
#line 6817 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 433:
#line 2212 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTC,   SA_CAST,	0); }
#line 6823 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 434:
#line 2213 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	1); }
#line 6829 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 435:
#line 2214 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	1); }
#line 6835 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 436:
#line 2215 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	0); }
#line 6841 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 437:
#line 2219 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6847 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 438:
#line 2220 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_ADD);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6853 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 439:
#line 2221 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_SUBTRACT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6859 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 440:
#line 2222 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_MULTIPLY);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6865 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 441:
#line 2223 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_DIVIDE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6871 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 442:
#line 2224 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_AND);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6877 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 443:
#line 2225 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_OR);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6883 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 444:
#line 2226 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_EQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6889 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 445:
#line 2227 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_NEQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6895 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 446:
#line 2228 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6901 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 447:
#line 2229 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6907 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 448:
#line 2230 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6913 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 449:
#line 2231 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6919 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 450:
#line 2232 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_MATCH);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6925 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 451:
#line 2233 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_NOT_MATCH);(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6931 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 452:
#line 2234 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_NOT);	(yyval.x)->a1.p = (yyvsp[0].x); }
#line 6937 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 453:
#line 2235 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_DEFINED);	(yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6943 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 454:
#line 2237 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6949 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 455:
#line 2238 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6955 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 456:
#line 2239 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6961 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 457:
#line 2241 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_PREF_GET); }
#line 6967 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 458:
#line 2243 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst_sa(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 6973 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 459:
#line 2245 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst_da(FI_EA_GET, (yyvsp[0].fda)); }
#line 6979 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 460:
#line 2247 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_IP); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6985 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 461:
#line 2248 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_LENGTH); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6991 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 462:
#line 2249 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_IP_MASK); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6997 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 463:
#line 2250 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7003 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 464:
#line 2251 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7009 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 465:
#line 2252 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7015 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 466:
#line 2262 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_PATH; }
#line 7021 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 467:
#line 2263 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_CLIST; }
#line 7027 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 468:
#line 2264 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_ECLIST; }
#line 7033 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 469:
#line 2265 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_LCLIST; }
#line 7039 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 470:
#line 2266 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 7045 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 471:
#line 2267 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 7051 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 472:
#line 2268 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 7057 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 473:
#line 2269 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 7063 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 474:
#line 2271 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 7069 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 475:
#line 2272 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7075 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 476:
#line 2275 "cf-parse.y" /* yacc.c:1648  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 7099 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 477:
#line 2297 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_QUITBIRD; }
#line 7105 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 478:
#line 2298 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_ACCEPT; }
#line 7111 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 479:
#line 2299 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_REJECT; }
#line 7117 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 480:
#line 2300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_ERROR; }
#line 7123 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 481:
#line 2301 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_NOP; }
#line 7129 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 482:
#line 2302 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_NONL; }
#line 7135 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 483:
#line 2306 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_PRINT); (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 7141 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 484:
#line 2309 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = NULL; }
#line 7147 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 485:
#line 2310 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7153 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 486:
#line 2311 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 7164 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 487:
#line 2319 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 7175 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 488:
#line 2325 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 7186 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 489:
#line 2333 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = NULL; }
#line 7192 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 490:
#line 2334 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7198 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 491:
#line 2338 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7208 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 492:
#line 2343 "cf-parse.y" /* yacc.c:1648  */
    {
     struct f_inst *i = f_new_inst(FI_CONDITION);
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7221 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 493:
#line 2351 "cf-parse.y" /* yacc.c:1648  */
    {
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 7234 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 494:
#line 2359 "cf-parse.y" /* yacc.c:1648  */
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7244 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 495:
#line 2364 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-3].fda));
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7253 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 496:
#line 2368 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst_sa(FI_RTA_SET, (yyvsp[-3].fsa));
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7264 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 497:
#line 2374 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst(FI_PREF_SET);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7273 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 498:
#line 2378 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-2].fda));
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->a1.p = NULL;
   }
#line 7283 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 499:
#line 2383 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_PRINT_AND_DIE); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 7289 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 500:
#line 2384 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7295 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 501:
#line 2385 "cf-parse.y" /* yacc.c:1648  */
    {
      (yyval.x) = f_new_inst(FI_SWITCH);
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 7305 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 502:
#line 2392 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 7311 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 503:
#line 2393 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, 'x', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7317 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 504:
#line 2394 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'a', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7323 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 505:
#line 2395 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'd', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7329 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 506:
#line 2396 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'f', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7335 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 507:
#line 2403 "cf-parse.y" /* yacc.c:1648  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);
}
#line 7345 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 515:
#line 2426 "cf-parse.y" /* yacc.c:1648  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 7362 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 516:
#line 2440 "cf-parse.y" /* yacc.c:1648  */
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 7385 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 517:
#line 2460 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7391 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 518:
#line 2461 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 7397 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 519:
#line 2462 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7403 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 520:
#line 2463 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 7409 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 521:
#line 2464 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 7415 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 522:
#line 2465 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 7421 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 523:
#line 2466 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 7427 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 524:
#line 2467 "cf-parse.y" /* yacc.c:1648  */
    {}
#line 7433 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 525:
#line 2471 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_NONE; }
#line 7439 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 526:
#line 2472 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 7445 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 527:
#line 2473 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 7451 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 528:
#line 2474 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 7457 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 529:
#line 2475 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 7463 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 530:
#line 2476 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 7469 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 536:
#line 2494 "cf-parse.y" /* yacc.c:1648  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 7475 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 537:
#line 2498 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.iface) = NULL; }
#line 7481 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 538:
#line 2499 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 7487 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 539:
#line 2500 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 7493 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 540:
#line 2504 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.a) = IPA_NONE; }
#line 7499 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 541:
#line 2505 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.a) = (yyvsp[0].a); }
#line 7505 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 542:
#line 2509 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 7511 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 543:
#line 2510 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i); }
#line 7517 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 544:
#line 2514 "cf-parse.y" /* yacc.c:1648  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 7537 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 545:
#line 2533 "cf-parse.y" /* yacc.c:1648  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 7543 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 546:
#line 2538 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
 }
#line 7573 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 548:
#line 2567 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 7579 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 549:
#line 2568 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 7585 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 550:
#line 2573 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 7591 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 551:
#line 2574 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 7597 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 553:
#line 2579 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 7603 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 554:
#line 2583 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 0; }
#line 7609 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 555:
#line 2584 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 1; }
#line 7615 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 556:
#line 2585 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 2; }
#line 7621 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 557:
#line 2586 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 3; }
#line 7627 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 558:
#line 2587 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 4; }
#line 7633 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 559:
#line 2588 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 5; }
#line 7639 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 560:
#line 2589 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 6; }
#line 7645 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 561:
#line 2590 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 7; }
#line 7651 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 562:
#line 2591 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 8; }
#line 7657 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 565:
#line 2597 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7663 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 566:
#line 2598 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7669 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 568:
#line 2600 "cf-parse.y" /* yacc.c:1648  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 7680 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 569:
#line 2606 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 7686 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 570:
#line 2607 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 7692 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 571:
#line 2608 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->rr_client = 1; }
#line 7698 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 572:
#line 2609 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->rs_client = 1; }
#line 7704 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 573:
#line 2610 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 7710 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 574:
#line 2611 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 7716 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 575:
#line 2612 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->multihop = 0; }
#line 7722 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 576:
#line 2613 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->multihop = 64; }
#line 7728 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 577:
#line 2614 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 7734 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 578:
#line 2615 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 7740 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 579:
#line 2616 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 7746 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 580:
#line 2617 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 7752 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 581:
#line 2618 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 7758 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 582:
#line 2619 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 7764 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 583:
#line 2620 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 7770 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 584:
#line 2621 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 7776 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 585:
#line 2622 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 7782 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 586:
#line 2623 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 7788 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 587:
#line 2624 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 7794 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 588:
#line 2625 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 7800 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 589:
#line 2626 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 7806 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 590:
#line 2627 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 7812 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 591:
#line 2628 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 7818 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 592:
#line 2629 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 7824 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 593:
#line 2630 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 7830 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 594:
#line 2631 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 7836 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 595:
#line 2632 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 7842 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 596:
#line 2633 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 7848 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 597:
#line 2634 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 7854 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 598:
#line 2635 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 7860 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 599:
#line 2636 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 7866 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 600:
#line 2637 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 7872 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 601:
#line 2638 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 7878 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 602:
#line 2639 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 7884 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 603:
#line 2640 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 7890 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 604:
#line 2641 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 7896 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 605:
#line 2642 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 7902 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 606:
#line 2643 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 7908 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 607:
#line 2644 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 7914 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 608:
#line 2645 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 7925 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 609:
#line 2651 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 7931 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 610:
#line 2652 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 7937 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 611:
#line 2653 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 7943 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 612:
#line 2654 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 7949 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 613:
#line 2655 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 7955 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 614:
#line 2656 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 7961 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 615:
#line 2657 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 7967 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 616:
#line 2658 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->allow_local_as = -1; }
#line 7973 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 617:
#line 2659 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 7979 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 618:
#line 2660 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 7985 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 619:
#line 2661 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 7991 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 620:
#line 2662 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 7997 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 621:
#line 2663 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->llgr_mode = (yyvsp[-1].i); }
#line 8003 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 622:
#line 2664 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
#line 8009 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 623:
#line 2665 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->llgr_time = (yyvsp[-1].i); }
#line 8015 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 624:
#line 2666 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 8021 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 625:
#line 2667 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 8027 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 626:
#line 2668 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 8033 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 627:
#line 2669 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 8039 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 628:
#line 2670 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->bfd = BGP_BFD_GRACEFUL; cf_check_bfd(1); }
#line 8045 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 629:
#line 2682 "cf-parse.y" /* yacc.c:1648  */
    {
  this_proto = proto_config_new(&proto_mrt, (yyvsp[-1].i));
}
#line 8053 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 631:
#line 2688 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->table_expr = (yyvsp[0].t); }
#line 8059 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 632:
#line 2689 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->filter = (yyvsp[0].f); }
#line 8065 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 633:
#line 2690 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->filter = (yyvsp[0].f); }
#line 8071 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 634:
#line 2691 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->filename = (yyvsp[0].t); }
#line 8077 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 635:
#line 2692 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->period = (yyvsp[0].i); }
#line 8083 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 636:
#line 2693 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->always_add_path = (yyvsp[0].i); }
#line 8089 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 639:
#line 2702 "cf-parse.y" /* yacc.c:1648  */
    { mrt_check_config(this_proto); }
#line 8095 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 640:
#line 2706 "cf-parse.y" /* yacc.c:1648  */
    { mrt_dump_cmd((yyvsp[-1].md)); }
#line 8101 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 641:
#line 2709 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
#line 8107 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 642:
#line 2710 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_ptr = (yyvsp[0].r)->table; }
#line 8113 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 643:
#line 2711 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_expr = (yyvsp[0].t); }
#line 8119 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 644:
#line 2712 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 8125 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 645:
#line 2713 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = (yyvsp[-1].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 8131 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 646:
#line 2714 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filename = (yyvsp[0].t); }
#line 8137 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 647:
#line 2721 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 8149 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 651:
#line 2737 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 8155 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 652:
#line 2738 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 8161 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 653:
#line 2739 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 8167 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 654:
#line 2740 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8173 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 655:
#line 2741 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 8179 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 656:
#line 2742 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 8185 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 657:
#line 2743 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8191 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 659:
#line 2747 "cf-parse.y" /* yacc.c:1648  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 8209 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 660:
#line 2762 "cf-parse.y" /* yacc.c:1648  */
    { ospf_area_finish(); }
#line 8215 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 663:
#line 2771 "cf-parse.y" /* yacc.c:1648  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 8221 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 664:
#line 2772 "cf-parse.y" /* yacc.c:1648  */
    { this_area->type = OPT_N; }
#line 8227 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 665:
#line 2773 "cf-parse.y" /* yacc.c:1648  */
    { this_area->summary = (yyvsp[0].i); }
#line 8233 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 666:
#line 2774 "cf-parse.y" /* yacc.c:1648  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 8239 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 667:
#line 2775 "cf-parse.y" /* yacc.c:1648  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8245 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 668:
#line 2776 "cf-parse.y" /* yacc.c:1648  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 8251 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 669:
#line 2777 "cf-parse.y" /* yacc.c:1648  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8257 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 670:
#line 2778 "cf-parse.y" /* yacc.c:1648  */
    { this_area->translator = (yyvsp[0].i); }
#line 8263 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 671:
#line 2779 "cf-parse.y" /* yacc.c:1648  */
    { this_area->transint = (yyvsp[0].i); }
#line 8269 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 672:
#line 2780 "cf-parse.y" /* yacc.c:1648  */
    { this_nets = &this_area->net_list; }
#line 8275 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 674:
#line 2781 "cf-parse.y" /* yacc.c:1648  */
    { this_nets = &this_area->enet_list; }
#line 8281 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 681:
#line 2793 "cf-parse.y" /* yacc.c:1648  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 8292 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 684:
#line 2807 "cf-parse.y" /* yacc.c:1648  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 8298 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 685:
#line 2808 "cf-parse.y" /* yacc.c:1648  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 8304 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 686:
#line 2809 "cf-parse.y" /* yacc.c:1648  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 8310 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 687:
#line 2813 "cf-parse.y" /* yacc.c:1648  */
    { ospf_iface_finish(); }
#line 8316 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 688:
#line 2814 "cf-parse.y" /* yacc.c:1648  */
    { ospf_iface_finish(); }
#line 8322 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 692:
#line 2823 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8328 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 693:
#line 2824 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8334 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 694:
#line 2825 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8340 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 695:
#line 2826 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8346 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 696:
#line 2827 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8352 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 697:
#line 2828 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8358 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 698:
#line 2829 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 8364 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 699:
#line 2830 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8370 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 700:
#line 2831 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8376 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 701:
#line 2832 "cf-parse.y" /* yacc.c:1648  */
    { ospf_check_auth(); }
#line 8382 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 702:
#line 2836 "cf-parse.y" /* yacc.c:1648  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 8403 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 703:
#line 2855 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 8409 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 704:
#line 2856 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8415 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 705:
#line 2857 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 8421 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 706:
#line 2858 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8427 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 707:
#line 2859 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8433 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 708:
#line 2860 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8439 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 709:
#line 2861 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8445 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 710:
#line 2862 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8451 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 711:
#line 2863 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8457 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 712:
#line 2864 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8463 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 713:
#line 2865 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8469 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 714:
#line 2866 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8475 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 715:
#line 2867 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8481 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 716:
#line 2868 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8487 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 717:
#line 2869 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8493 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 718:
#line 2870 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 8499 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 719:
#line 2871 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 8505 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 720:
#line 2872 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8511 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 721:
#line 2873 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 8517 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 722:
#line 2874 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 8523 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 723:
#line 2875 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 8529 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 724:
#line 2876 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 8535 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 725:
#line 2877 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8541 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 726:
#line 2878 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 8547 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 728:
#line 2880 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 8553 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 729:
#line 2881 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8559 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 730:
#line 2882 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8565 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 731:
#line 2883 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->rx_buffer = 0; }
#line 8571 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 732:
#line 2884 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 8577 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 733:
#line 2885 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 8583 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 734:
#line 2886 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 8589 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 735:
#line 2887 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 8595 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 736:
#line 2888 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 8601 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 737:
#line 2889 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 8607 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 738:
#line 2890 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->ttl_security = 2; }
#line 8613 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 739:
#line 2891 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8619 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 740:
#line 2892 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 8625 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 741:
#line 2893 "cf-parse.y" /* yacc.c:1648  */
    { ospf_check_auth(); }
#line 8631 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 745:
#line 2904 "cf-parse.y" /* yacc.c:1648  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 8642 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 747:
#line 2914 "cf-parse.y" /* yacc.c:1648  */
    { this_pref->hidden = 1; }
#line 8648 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 748:
#line 2915 "cf-parse.y" /* yacc.c:1648  */
    { this_pref->tag = (yyvsp[0].i); }
#line 8654 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 751:
#line 2924 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 8660 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 752:
#line 2925 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1; }
#line 8666 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 753:
#line 2929 "cf-parse.y" /* yacc.c:1648  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 8677 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 754:
#line 2938 "cf-parse.y" /* yacc.c:1648  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 8701 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 756:
#line 2961 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8707 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 757:
#line 2965 "cf-parse.y" /* yacc.c:1648  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 8713 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 763:
#line 2979 "cf-parse.y" /* yacc.c:1648  */
    { ospf_iface_finish(); }
#line 8719 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 764:
#line 2985 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 8725 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 765:
#line 2988 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8731 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 766:
#line 2991 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8737 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 767:
#line 2996 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 8743 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 768:
#line 2999 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 8749 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 769:
#line 3004 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 8755 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 770:
#line 3007 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 8761 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 771:
#line 3011 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 8767 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 772:
#line 3014 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 8775 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 773:
#line 3017 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 8781 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 774:
#line 3018 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 8787 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 775:
#line 3019 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 8793 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 776:
#line 3020 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 8799 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 777:
#line 3021 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 8805 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 778:
#line 3022 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 8811 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 779:
#line 3023 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 8817 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 780:
#line 3024 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 8823 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 781:
#line 3030 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 8832 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 784:
#line 3039 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 8842 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 785:
#line 3044 "cf-parse.y" /* yacc.c:1648  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 8848 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 786:
#line 3045 "cf-parse.y" /* yacc.c:1648  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 8854 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 787:
#line 3052 "cf-parse.y" /* yacc.c:1648  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
#line 8869 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 789:
#line 3065 "cf-parse.y" /* yacc.c:1648  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 8875 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 790:
#line 3066 "cf-parse.y" /* yacc.c:1648  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8881 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 791:
#line 3067 "cf-parse.y" /* yacc.c:1648  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 8887 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 796:
#line 3081 "cf-parse.y" /* yacc.c:1648  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 8913 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 797:
#line 3104 "cf-parse.y" /* yacc.c:1648  */
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 8946 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 798:
#line 3134 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 8952 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 799:
#line 3135 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 8958 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 800:
#line 3136 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 8964 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 801:
#line 3137 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 8970 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 802:
#line 3138 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->address = (yyvsp[0].a); }
#line 8976 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 803:
#line 3139 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 8982 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 804:
#line 3140 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 8991 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 805:
#line 3144 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 8997 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 806:
#line 3145 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 9003 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 807:
#line 3146 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 9009 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 808:
#line 3147 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 9015 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 809:
#line 3148 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->update_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 9021 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 810:
#line 3149 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 9027 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 811:
#line 3150 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 9033 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 812:
#line 3151 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 9039 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 813:
#line 3152 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 9045 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 814:
#line 3153 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 9051 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 815:
#line 3154 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 9057 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 816:
#line 3155 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 9063 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 817:
#line 3156 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 9069 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 818:
#line 3157 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->ttl_security = 2; }
#line 9075 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 819:
#line 3158 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 9081 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 820:
#line 3159 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 9087 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 821:
#line 3160 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 9093 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 822:
#line 3161 "cf-parse.y" /* yacc.c:1648  */
    { rip_check_auth(); }
#line 9099 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 823:
#line 3165 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 9105 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 824:
#line 3166 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 9111 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 825:
#line 3167 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 9117 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 826:
#line 3168 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 9123 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 832:
#line 3189 "cf-parse.y" /* yacc.c:1648  */
    { rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 9129 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 833:
#line 3192 "cf-parse.y" /* yacc.c:1648  */
    { rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 9135 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 834:
#line 3198 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 9144 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 837:
#line 3207 "cf-parse.y" /* yacc.c:1648  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 9150 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 838:
#line 3208 "cf-parse.y" /* yacc.c:1648  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 9156 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 839:
#line 3209 "cf-parse.y" /* yacc.c:1648  */
    { static_route_finish(); }
#line 9162 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 840:
#line 3212 "cf-parse.y" /* yacc.c:1648  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
#line 9174 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 841:
#line 3222 "cf-parse.y" /* yacc.c:1648  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
#line 9188 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 842:
#line 3231 "cf-parse.y" /* yacc.c:1648  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 9197 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 843:
#line 3235 "cf-parse.y" /* yacc.c:1648  */
    {
     this_srt_nh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
   }
#line 9205 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 844:
#line 3241 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->mp_next = this_srt_nh; }
#line 9211 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 845:
#line 3242 "cf-parse.y" /* yacc.c:1648  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 9217 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 846:
#line 3246 "cf-parse.y" /* yacc.c:1648  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 9227 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 847:
#line 3251 "cf-parse.y" /* yacc.c:1648  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 9238 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 848:
#line 3257 "cf-parse.y" /* yacc.c:1648  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 9246 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 849:
#line 3260 "cf-parse.y" /* yacc.c:1648  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 9255 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 850:
#line 3265 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9261 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 851:
#line 3266 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9267 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 852:
#line 3267 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9273 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 853:
#line 3268 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9279 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 854:
#line 3269 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 9285 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 855:
#line 3273 "cf-parse.y" /* yacc.c:1648  */
    { *this_srt_last_cmd = (yyvsp[0].x); this_srt_last_cmd = &((yyvsp[0].x)->next); }
#line 9291 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 856:
#line 3274 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->use_bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 9297 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 861:
#line 3289 "cf-parse.y" /* yacc.c:1648  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 9303 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 932:
#line 3297 "cf-parse.y" /* yacc.c:1648  */
    { bgp_check_config(BGP_CFG); }
#line 9309 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 934:
#line 3297 "cf-parse.y" /* yacc.c:1648  */
    { ospf_proto_finish(); }
#line 9315 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 945:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 9321 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 946:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 9327 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 947:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 9333 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 948:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 9339 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 949:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 9345 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 950:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 9351 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 951:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 9357 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 952:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 9363 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 953:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 9369 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 954:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 9375 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 955:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 9381 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 956:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 9387 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 957:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 9393 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 958:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 9399 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 959:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 9405 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 960:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 9411 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 961:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 9417 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 962:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 9423 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 963:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
#line 9429 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 964:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
#line 9435 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 965:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
#line 9441 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 966:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
#line 9447 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 967:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
#line 9453 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 968:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
#line 9459 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 969:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
#line 9465 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 970:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
#line 9471 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 971:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
#line 9477 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 972:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
#line 9483 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 973:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
#line 9489 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 974:
#line 3300 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
#line 9495 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 975:
#line 3301 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 9501 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 976:
#line 3301 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = (struct f_dynamic_attr) {}; }
#line 9507 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 977:
#line 3302 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 9513 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 978:
#line 3303 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 9519 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 979:
#line 3304 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 9525 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 980:
#line 3305 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 9531 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 981:
#line 3306 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 9537 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 982:
#line 3307 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 9543 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 983:
#line 3308 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 9549 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 984:
#line 3309 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 9555 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 985:
#line 3310 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 9561 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 986:
#line 3311 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 9567 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 987:
#line 3312 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 9573 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 988:
#line 3313 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
#line 9579 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 989:
#line 3313 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 9585 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 990:
#line 3313 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 9591 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 991:
#line 3313 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 9597 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 992:
#line 3313 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 9603 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 993:
#line 3313 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 9609 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 994:
#line 3313 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 9615 "cf-parse.tab.c" /* yacc.c:1648  */
    break;


#line 9619 "cf-parse.tab.c" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3315 "cf-parse.y" /* yacc.c:1907  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/mrt/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

